/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Apr 14, 2003
 * Time: 1:09:43 AM
 */

package EVolve;

import EVolve.exceptions.DataProcessingException;

public class ProcessingThread implements Runnable{
    private Thread thread = null;

    public ProcessingThread() {
        thread = new Thread(this);
    }

    public void start() {
        thread.start();
    }

    public void join() throws InterruptedException {
        thread.join();
    }

    public synchronized void run() {
        try {
            Scene.getDataManager().sendEvents();
            Scene.getVisualizationManager().visualize();
            Scene.setStatus("Visualization finished.");
        } catch (DataProcessingException e) {
            Scene.setStatus(e.getMessage());
        }
    }
}
