/* EVolve - an Extensible Software Visualization Framework
 * Copyright (C) 2001-2002 Qin Wang
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * EVolve is distributed at http://www.sable.mcgill.ca/EVolve/
 */

package EVolve.data;

import java.awt.Color;
import java.util.HashMap;
import java.util.Iterator;

import EVolve.Scene;

public class ElementFilter {
    private int[] linkIndex;
    private HashMap[] color;
    protected Color colorBlue = new Color(120, 160, 255);

    public ElementFilter(ElementDefinition elementDefinition, Selection[] selection) {
        int count = 0;
        for (int i = 0; i < elementDefinition.getFieldDefinition().length; i++) {
            if (elementDefinition.getFieldDefinition()[i].getReference() != -1) {
                count++;
            }
        }
        linkIndex = new int[count];
        count = 0;
        for (int i = 0; i < elementDefinition.getFieldDefinition().length; i++) {
            if (elementDefinition.getFieldDefinition()[i].getReference() != -1) {
                linkIndex[count] = i;
                count++;
            }
        }

        color = new HashMap[linkIndex.length];
        for (int i = 0; i < color.length; i++) {
            //color[i] = new Color[Scene.getDataManager().getEntity()[elementDefinition.getFieldDefinition()[linkIndex[i]].getReference()].size()];
            color[i] = new HashMap();
            HashMap entities = Scene.getDataManager().getEntity()[elementDefinition.getFieldDefinition()[linkIndex[i]].getReference()];
            Iterator it = entities.keySet().iterator();
            while (it.hasNext()) {
                Long key = (Long)it.next();
                color[i].put(key,colorBlue);
                for (int k = 0; k < selection.length; k++) {
                    boolean isSelected = true;

                    for (int l = 0; l < selection[k].getLink().length; l++) {
                        if ((selection[k].getLink()[l].getSourceType() == elementDefinition.getType()) &&
                            (selection[k].getLink()[l].getSourceIndex() == linkIndex[i])) {
                            isSelected = false;
                            for (int m = 0; m < selection[k].getSelected().length; m++) {
                                if (selection[k].getLink()[l].getTarget(key.longValue()) == selection[k].getSelected()[m].getId()) {
                                    isSelected = true;
                                    if ((color[i].get(key) == colorBlue) && (selection[k].getColor() != null)) {
                                        color[i].put(key,selection[k].getColor());
                                    }
                                    break;
                                }
                            }
                            break;
                        }
                    }
                    if ((!isSelected) && (selection[k].getColor() == null)) {
                        color[i].put(key,null);
                        break;
                    }
                }
            }

            /*for (int j = 0; j < color[i].length; j++) {
                color[i][j] = colorBlue;//Color.black;
                for (int k = 0; k < selection.length; k++) {
                    boolean isSelected = true;
                    for (int l = 0; l < selection[k].getLink().length; l++) {
                        if ((selection[k].getLink()[l].getSourceType() == elementDefinition.getType()) && (selection[k].getLink()[l].getOriginMappedId() == linkIndex[i])) {
                            isSelected = false;
                            for (int m = 0; m < selection[k].getSelected().length; m++) {
                                if (selection[k].getLink()[l].getTarget(j) == selection[k].getSelected()[m].getId()) {
                                    isSelected = true;
                                    if ((color[i][j] == colorBlue) && (selection[k].getColor() != null)) {
                                        color[i][j] = selection[k].getColor();
                                    }
                                    break;
                                }
                            }
                            break;
                        }
                    }
                    if ((!isSelected) && (selection[k].getColor() == null)) {
                        color[i][j] = null;
                        break;
                    }
                }
            }*/
        }
    }

    public Color getColor(Element element) {
        Color result = colorBlue;//Color.black;
        for (int i = 0; i < linkIndex.length; i++) {
            if (color[i].get(new Long(element.getField()[linkIndex[i]])) == null) {
                return null;
            }
            if (result == colorBlue/*Color.black*/) {
                result = (Color)color[i].get(new Long(element.getField()[linkIndex[i]]));
            }
        }
        return result;
    }
}