/* EVolve - an Extensible Software Visualization Framework
 * Copyright (C) 2001-2002 Qin Wang
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * EVolve is distributed at http://www.sable.mcgill.ca/EVolve/
 */

package EVolve.data;

/**
 * Event builder.
 */
public class EventBuilder extends ElementBuilder {
    /**
     * Creates an event builder.
     *
     * @param   eventName name of the events
     * @param   eventDescription description of the events
     */
    public EventBuilder(String eventName, String eventDescription) {
        super(eventName, eventDescription);
    }

    /**
     * Builds the element definition.
     *
     * @return  the element definition
     */
    public EventDefinition buildDefinition() {
        return super.buildEventDefinition();
    }


    /**
     * Starts building new event.
     */
    public void newEvent() {
        super.newEvent();
    }

    /**
     * Starts building new event.
     */
    public void newEvent(boolean isOptional) {
        super.newEvent(isOptional);
    }

    /**
     * Builds the event.
     *
     * @return  the event
     */
    public Event buildEvent() {
        return super.buildEvent();
    }


    public Event buildEvent(boolean isOptional) {
        return super.buildEvent(isOptional);
    }
}