/* EVolve - an Extensible Software Visualization Framework
 * Copyright (C) 2001-2002 Qin Wang
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * EVolve is distributed at http://www.sable.mcgill.ca/EVolve/
 */

package EVolve.data;

import java.util.ArrayList;

public class FieldDefinition implements Cloneable{
    private String name;
    private int index;
    private ArrayList property;
    private int reference;
    private String description;

    FieldDefinition(String name, int index, int reference, String description) {
        this.name = name;
        this.index = index;
        this.property = new ArrayList();
        this.reference = reference;
        this.description = description;
    }

    void addProperty(String property) {
        this.property.add(property);
    }

    public String getName() {
        return name;
    }

    public int getIndex() {
        return index;
    }

    public boolean hasProperty(String property) {
        return ((property == null) || (this.property.indexOf(property) != -1));
    }

    public int getReference() {
        return reference;
    }

    public String getDescription() {
        return description;
    }

    public String[] getProperties() {
        String[] returnVal = new String[property.size()];
        for (int i=0; i< returnVal.length; i++) {
            returnVal[i] = (String)property.get(i);
        }

        return returnVal;
    }

    public Object clone() {
        FieldDefinition o = null;
        try {
            o = (FieldDefinition)super.clone();
        } catch (CloneNotSupportedException e) {
            e.printStackTrace();
            return null;
        }

        o.name = name;
        o.property = (ArrayList)property.clone();
        o.description = description;
        return o;
    }
}