/* EVolve - an Extensible Software Visualization Framework
 * Copyright (C) 2001-2002 Qin Wang
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * EVolve is distributed at http://www.sable.mcgill.ca/EVolve/
 */

package EVolve.data;

import java.util.HashMap;

public class ValueComparator implements EntityComparator, Cloneable {
    private String name;
    private boolean increase;
    private int[] value;
    private HashMap EntityId2Int;

    public ValueComparator(String name, boolean increase, int[] value, HashMap EntityId2Int) {
        this.name = name;
        this.increase = increase;
        this.value = value;
        this.EntityId2Int = EntityId2Int;
    }

    public String getName() {
        return name;
    }

    public int compare(Entity entity1, Entity entity2) {
        int entityId1 = ((Integer)EntityId2Int.get(entity1.getName())).intValue();
        int entityId2 = ((Integer)EntityId2Int.get(entity2.getName())).intValue();
        if (increase) {
            return value[entityId1] - value[entityId2];
        } else {
            return value[entityId2] - value[entityId1];
        }
    }

    public Object clone() {
        ValueComparator o = null;
        try {
            o = (ValueComparator)super.clone();
        } catch (CloneNotSupportedException e) {
            return null;
        }
        o.name = name;
        if (value != null) {
            o.value = new int[value.length];
            for (int i=0; i<value.length; i++)
                o.value[i] = value[i];
        }
        return o;
    }
}