/*
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: 2002-10-22
 * Time: 20:12:14
 * To change this template use Options | File Templates.
 */

package EVolve.util;

import java.awt.Color;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Random;

public class ColorCache implements Cloneable{
    private HashMap colorMap;
    private Random random;
    private final long seed = 2003213813;
    private Color[] defaultColors = {
        new Color(51,153,204), new Color(187,156,26), new Color(153,204,51),new Color(153,51,204),
        new Color(204,51,153), new Color(204,153,51), new Color(51,204,0),new Color(51,0,204),
        new Color(204,0,51), new Color(204,51,0), new Color(0,51,204),new Color(0,204,51),
        new Color(204,0,204), new Color(204,204,0), new Color(0,204,204),new Color(51,153,0),
        new Color(51,0,153), new Color(153,0,51), new Color(153,51,0),new Color(0,51,153),
        new Color(0,153,51), new Color(153,204,0), new Color(153,0,204),new Color(0,204,153),
        new Color(0,153,204), new Color(204,0,153), new Color(204,153,0),new Color(151,255,151),
        new Color(255,151,151), new Color(151,151,255), new Color(204,204,255),new Color(255,204,204),
        new Color(204,255,204), new Color(251,151,180), new Color(251,180,151),new Color(151,180,251),
        new Color(151,251,180), new Color(180,251,151), new Color(180,151,251),new Color(145,244,45),
        new Color(145,45,244), new Color(45,244,145), new Color(45,145,244),new Color(244,100,45),
        new Color(244,45,145), new Color(244,145,195), new Color(0,0,255),new Color(51,204,153),
        new Color(0,255,0), new Color(130,28,247), new Color(179,247,98),new Color(247,28,130),
        new Color(200,160,88), new Color(28,247,130), new Color(198,130,247),new Color(0,128,255),
        new Color(0,255,128), new Color(255,128,177), new Color(255,180,128),new Color(128,200,255),
        new Color(255,128,0), new Color(128,255,0), new Color(255,0,0),new Color(102,102,255)
    };
    private int leftColor;

    public ColorCache() {
        colorMap = new HashMap();
        leftColor = defaultColors.length -1;
        random = new Random();
        random.setSeed(seed);
    }

    private Color getRandomColor() {
        int sum = 0;
        int rand[] = new int[3];

        if (leftColor>=0) {
            return defaultColors[leftColor--];
        }

        do {
            while (sum<70) {
                for (int i=0; i<rand.length;i++) {
                    rand[i] = 500;
                    while (rand[i]>255) {
                        rand[i] = (int)(random.nextDouble()*10000);
                    }
                }
                sum = rand[0] + rand[1] + rand[2];
            }
            sum = 0;
        } while (colorMap.containsValue(new Color(rand[0],rand[1],rand[2])));

        return new Color(rand[0],rand[1],rand[2]);
    }

    public Color getNextColor(long methodId) {
        Color color;
        if (!colorMap.containsKey(new Long(methodId))) {
            color = getRandomColor();
            colorMap.put(new Long(methodId),color);
            return color;
        }
        return (Color)colorMap.get(new Long(methodId));
    }

    public long getKeyFromColor(Color color) {
        Iterator it = colorMap.keySet().iterator();
        long methodId = -1;

        while (it.hasNext()) {
            Long key = (Long)it.next();
            if (color != ((Color)colorMap.get(key))) continue;

            methodId = key.longValue();
            return methodId;
        }
        return methodId;
    }

    public Object clone() {
        ColorCache o = null;
        try {
            o = (ColorCache)super.clone();
        } catch (CloneNotSupportedException e) {
            e.printStackTrace();
            return null;
        }
        o.colorMap = (HashMap)colorMap.clone();
        o.defaultColors = new Color[defaultColors.length];
        for (int i=0; i<defaultColors.length; i++)
            o.defaultColors[i] = defaultColors[i];
        return o;
    }
}
