/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Apr 11, 2003
 * Time: 5:02:28 PM
 */

package EVolve.util;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Stack;

import javax.swing.JOptionPane;

import EVolve.Scene;
import EVolve.visualization.Visualization;
import EVolve.visualization.XYViz.XYVisualization;

public class HelperFuncs {
    public static boolean inDebug = false;
    public static int stop = -1;

    public static HashMap cloneHashMap(HashMap source) {
         if (source == null) return null;

         Iterator it = source.keySet().iterator();
         HashMap target = new HashMap();
         while (it.hasNext()) {
             Object key = it.next();
             target.put(key, source.get(key));
         }

         return target;
     }

    public static HashSet cloneHashSet(HashSet source) {
         if (source == null) return null;

         Iterator it = source.iterator();
         HashSet target = new HashSet();
         while (it.hasNext()) {
             target.add(it.next());
         }

         return target;
     }

    public static ArrayList cloneArrayList(ArrayList source) {
        ArrayList target = new ArrayList();

        for (int i=0; i<source.size(); i++) {
            target.add(source.get(i));
        }

        return target;
    }

    public static Stack cloneStack(Stack source) {
        Stack target = new Stack();

        for (int i=0; i<source.size(); i++) {
            target.add(source.get(i));
        }

        return target;
    }

    public static XYVisualization getActiveXYViz() {
        Visualization visual = Scene.getVisualizationManager().getActiveVisualization();
        if ((visual == null) || (!(visual instanceof XYVisualization)))
            return null;

        return (XYVisualization)visual;
    }

    public static void getDebugNo() {
        String abc = JOptionPane.showInputDialog("stop condition");
        try {
            stop = Integer.parseInt(abc);
        } catch (Exception e) {

        }
        inDebug = false;
        Scene.getUIManager().resetDebugMenu(inDebug);
    }

    public static long translateHexString(String line) throws NumberFormatException{
        long retVal = 0, factor = 1;
        char[] buf = new char[line.length()];

        line.getChars(0,line.length(),buf,0);

        for (int i=buf.length-1; i>=0; i--) {
            switch (buf[i]) {
                case '0':
                case '1':
                case '2':
                case '3':
                case '4':
                case '5':
                case '6':
                case '7':
                case '8':
                case '9':
                    retVal = retVal + ((int)buf[i] - 0x30)*factor;
                    break;
                case 'a':
                case 'A':
                    retVal = retVal + 10 * factor;
                    break;
                case 'b':
                case 'B':
                    retVal = retVal + 11 * factor;
                    break;
                case 'c':
                case 'C':
                    retVal = retVal + 12 * factor;
                    break;
                case 'd':
                case 'D':
                    retVal = retVal + 13 * factor;
                    break;
                case 'e':
                case 'E':
                    retVal = retVal + 14 * factor;
                    break;
                case 'f':
                case 'F':
                    retVal = retVal + 15 * factor;
                    break;
                default:
                    throw new NumberFormatException();
            }
            factor = factor*16;
        }
        return retVal;

    }

    public static String restoreTimeFormat(long time) {
        long factor = 60L*60L*1000000L;
        String[] tokens = {"h ", "m ", "s ", " "};
        String returnVal = "";
        int i = 0;

        for (i=0; i<4; i++) {
            returnVal = returnVal + time/factor + tokens[i];
            time = time % factor;
            if (factor >1000000) {
                factor = factor/60;
            } else {
                factor = factor/1000;
            }
        }

        returnVal = returnVal + time%(60L*60L*1000000L);

        return returnVal;
    }

}
