/*
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: 2002-10-4
 * Time: 16:54:10
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package EVolve.util;

import java.util.ArrayList;

public class MethodInvokingTrace {
    private ArrayList trace, stack;
    private int invocationNum;
    //private ReferenceDimension xAxis;

    public MethodInvokingTrace() {
        trace = new ArrayList();
        stack = new ArrayList();
        invocationNum = 0;
    }

    public void updateMethodTrace(int calleeId, boolean methodEntry) {
    int[] methodFootprint = new int[2];

        methodFootprint[0] = calleeId;
        methodFootprint[1] = methodEntry ? 1 : 0; // 1 means a entry event, 0 means exit event
        if (!methodEntry && (trace.size() == 0)) return;

        if (methodEntry) invocationNum++;
        trace.add(methodFootprint);
    }

    public void updateMethodTrace2(int calleeId) {
        trace.add(new Integer(calleeId));
    }

    public ArrayList getCallerChains(int callerId,int calleeId) {
        ArrayList returnVal = new ArrayList();
        ArrayList callerChain;
        int footprint[];

        stack.clear();
        for (int i = 0; i<trace.size(); i++) {
            footprint = (int[])trace.get(i);
        
            if (footprint[1] == 0) {// method exit
                if (stack.size() != 0) stack.remove(stack.size()-1);
            }
            else {
                stack.add(new Integer(footprint[0]));
                if ((stack.size()>=2) &&
                    (((Integer)stack.get(stack.size()-1)).intValue() == calleeId) &&
                    (((Integer)stack.get(stack.size()-2)).intValue() == callerId)) {
                    callerChain = (ArrayList)stack.clone();
                    callerChain.remove(callerChain.size()-1);
                    returnVal.add(callerChain);
                }
            }

        }

        // remove duplicates
        ArrayList temp = new ArrayList(), tempReturnVal = new ArrayList();
        for (int i = 1; i< returnVal.size(); i++) {
            temp = (ArrayList)returnVal.get(i-1);
            boolean found = false;
            for (int j=i; j<returnVal.size(); j++) {
                callerChain = (ArrayList)returnVal.get(j);
                if (temp.size() != callerChain.size())
                    continue;
                for (int k=0; k< temp.size(); k++) {
                    if (((Integer)temp.get(k)).intValue() != ((Integer)callerChain.get(k)).intValue()) {
                        found = false;
                        break;
                    }
                    found = true;
                }
                if (found) break;
            }
            if (!found)
                tempReturnVal.add(temp);
        }
        if (tempReturnVal.size()>0)
            returnVal = tempReturnVal;
        return returnVal;
    }
    
    public ArrayList getCallerChain(int callerId, int calleeId) {
        ArrayList callerChain = new ArrayList();
        int[] footprint;

        callerChain.add(new Integer(callerId));
        stack.clear();
        for (int i = 0; i<trace.size(); i++) {
            footprint = (int[])trace.get(i);

            if (footprint[1] == 0) { // method exit event
                if (stack.size() != 0) stack.remove(stack.size()-1);
            } else {
                stack.add(new Integer(footprint[0]));
                if ((stack.size()>=2) &&
                    (((Integer)stack.get(stack.size()-1)).intValue() == calleeId) &&
                    (((Integer)stack.get(stack.size()-2)).intValue() == callerId)) {
                    callerChain = (ArrayList)stack.clone();
                    callerChain.remove(callerChain.size()-1);
                    break;
                }
            }
        }

        return callerChain;
    }

    public ArrayList getCallees(int callerId, int calleeId) {
        ArrayList callees = new ArrayList();
        int footprint[],i;

        stack.clear();
        for (i = 0; i<trace.size(); i++) {
            footprint = (int[])trace.get(i);

            if (footprint[1] == 0) { // method exit event
                if (stack.size() != 0) stack.remove(stack.size()-1);
            } else {
                stack.add(new Integer(footprint[0]));
                if ((stack.size()>=3) &&
                    (((Integer)stack.get(stack.size()-2)).intValue() == calleeId) &&
                    (((Integer)stack.get(stack.size()-3)).intValue() == callerId)) {
                    callees.add(new Integer(footprint[0]));
                }
            }
        }

        // remove duplicates
        ArrayList temp = new ArrayList();
        for (i=0; i<callees.size();i++) {
            int value = ((Integer)callees.get(i)).intValue();
            boolean found = false;
            if (i==0) {
                temp.add(new Integer(value));
                continue;
            }
            for (int j=0; j<temp.size();j++) {
                if (value == ((Integer)temp.get(j)).intValue()) {
                    found = true;
                    break;
                }
            }
            if (!found)
                temp.add(new Integer(value));
        }
        callees = temp;
        return callees;
    }

    public int size() {
        return trace.size();
    }

    public ArrayList getMethodTrace() {
        return trace;
    }
}
