/*
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: 2002-10-17
 * Time: 17:11:15
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package EVolve.util;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JList;
import javax.swing.JPanel;

import EVolve.Scene;
import EVolve.visualization.AutoImage;

public class ThreadChooser{
    private ArrayList threadSet;
    private HashMap imageMap,colorMap;
    private JDialog dialog;
    private JList threads;
    private DefaultListModel threadListModel;
    private AutoImage mergedImage;
    private JComboBox comboThread;
    private int [] indices;
    private boolean multiChoice;
    private String thread;


    public ThreadChooser(HashMap imageMap,boolean multiChoice) {
        this.imageMap = imageMap;
        colorMap = new HashMap();
        this.multiChoice = multiChoice;
    }

    private String showMultiChoiceDialog() {

        if (imageMap.size() == 0) return null;
        dialog = new JDialog(Scene.getFrame(), "Choose thread & color to be visualized", true);

        dialog.setBounds(new Rectangle(250,100));

        threadListModel = new DefaultListModel();
        threadSet = new ArrayList();
        threads = new JList(threadListModel);
        Iterator it = imageMap.keySet().iterator();
        while (it.hasNext()) {
            threadSet.add("Thread "+it.next());
        }
        for (int i=0; i<threadSet.size(); i++) {
            String item = (String)threadSet.get(i);
            threadListModel.addElement(item);
        }
        dialog.getContentPane().add(threads,BorderLayout.CENTER);

        JPanel panelButton = new JPanel(new FlowLayout());
        dialog.getContentPane().add(panelButton, BorderLayout.SOUTH);

        JButton buttonColor = new JButton("Coloring");
        buttonColor.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                selectColor();
            }
        });
        panelButton.add(buttonColor);

        JButton buttonOK = new JButton("OK");
        buttonOK.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (threads.getSelectedIndices().length == 0) {
                    Scene.showErrorMessage("You must choose at least one thread!");
                    return;
                }
                indices = threads.getSelectedIndices();
                dialog.setVisible(false);
                dialog = null;
            }
        });
        panelButton.add(buttonOK);

        /*JButton buttonCancel = new JButton("Cancel");
        buttonCancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                dialog.setVisible(false);
            }
        });
        panelButton.add(buttonCancel);*/
        dialog.pack();
        Scene.getUIManager().showDialog(dialog, dialog.getWidth(), dialog.getHeight());
        return null;
    }

    private String showSingleChoiceDialog() {
        dialog = new JDialog(Scene.getFrame(), "Choose thread to be visualized", true);

        Box boxMain = new Box(BoxLayout.Y_AXIS);
        dialog.getContentPane().add(boxMain,BorderLayout.CENTER);
        dialog.setBounds(new Rectangle(250,100));
        comboThread = new JComboBox();
        thread = null;

        Iterator it = imageMap.keySet().iterator();
        while (it.hasNext()) {
            comboThread.addItem("Thread "+it.next());
        }
        boxMain.add(comboThread);

        JPanel panelButton = new JPanel(new FlowLayout());
        dialog.getContentPane().add(panelButton, BorderLayout.SOUTH);

        JButton buttonOK = new JButton("OK");
        buttonOK.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (!validateThread())
                    Scene.showErrorMessage("No data is available for this thread.");
                else {
                    thread = (String)comboThread.getSelectedItem();
                    dialog.setVisible(false);
                }
            }
        });
        panelButton.add(buttonOK);

        JButton buttonCancel = new JButton("Cancel");
        buttonCancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                dialog.setVisible(false);
            }
        });
        panelButton.add(buttonCancel);
        dialog.pack();
        Scene.getUIManager().showDialog(dialog, dialog.getWidth(), dialog.getHeight());

        dialog = null;
        return thread;
    }

    public String showDialog() {
        if (multiChoice)
            return showMultiChoiceDialog();
        else
            return showSingleChoiceDialog();
    }

    private void selectColor() {
        int index = threads.getSelectedIndex();

        if (index != -1) {
            Color newColor = JColorChooser.showDialog(Scene.getFrame(), "Choose a color", Color.black);
            if (newColor != null) {
                colorMap.put(new Integer(index),newColor);
                threadListModel.removeAllElements();

                for (int i=0; i<threadSet.size(); i++) {
                    if (colorMap.get(new Integer(i)) == null)
                        threadListModel.addElement(threadSet.get(i));
                    else
                        threadListModel.addElement("<html><font color=#" + getColorHex((Color)colorMap.get(new Integer(i))) + ">"
                                             + threadSet.get(i) +" </font></html>" );
                }
            }
        }
    }

    public AutoImage coloringImages(HashMap imageMap) {
        mergedImage = new AutoImage();
        for (int i=0; i<indices.length; i++) {
            Color newColor = (Color)colorMap.get(new Integer(indices[i]));
            String threadId = (String)threadSet.get(indices[i]);
            threadId = threadId.substring(7,threadId.length());
            AutoImage image = (AutoImage)imageMap.get(new Long(threadId));
            int w = image.getW();
            int h = image.getH();
            for (int j=0; j<w; j++) {
                for (int k=0; k<h; k++) {
                    if (image.getColor(j,k) != null)
                        if (mergedImage.getColor(j,k) != null)
                            mergedImage.setColor(j,k,new Color(153,0,153));
                        else
                            if (newColor != null) {
                                mergedImage.setColor(j,k,newColor);
                            } else mergedImage.setColor(j,k,image.getColor(j,k));
                }
            }

        }
        return mergedImage;
    }

    private String getColorHex(Color color) {
        String returnVal = Integer.toHexString(color.getBlue());
        if (returnVal.length() < 2) {
            returnVal = "0" + returnVal;
        }
        returnVal = Integer.toHexString(color.getGreen()) + returnVal;
        if (returnVal.length() < 4) {
            returnVal = "0" + returnVal;
        }
        returnVal = Integer.toHexString(color.getRed()) + returnVal;
        if (returnVal.length() < 6) {
            returnVal = "0" + returnVal;
        }

        return returnVal;
    }

    public AutoImage getMergedImage() {
        return mergedImage;
    }

    private boolean validateThread() {
        AutoImage img;

        String selected = (String)comboThread.getSelectedItem();
        img = (AutoImage)imageMap.get(new Long(selected.substring(7,selected.length())));
        if (img.getW()*img.getH() <= 0) return false;

        return true;
    }


}
