/*
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * ACL Lab, School of Computer Science, Montreal, QC
 * Date: 2002-8-28
 * Time: 23:40:49
 */
package EVolve.util;

import EVolve.util.batchutils.BatchRunner;
import EVolve.util.overlappers.OverlapVisualizationRunner;
import EVolve.util.predefinedutils.PredefinedVisualizationRunner;
import EVolve.util.unifyutils.UnifiedVisualizationRunner;

public class ToolsManager {

    private BatchRunner batchRunner;
    private PredefinedVisualizationRunner predefinedVisualizationRunner;
    private UnifiedVisualizationRunner linkedVisualizationRunner;
    private OverlapVisualizationRunner overlapVisualizationRunner;

    public ToolsManager() {
        batchRunner = new BatchRunner();
        predefinedVisualizationRunner = new PredefinedVisualizationRunner();
        linkedVisualizationRunner = new UnifiedVisualizationRunner();
        overlapVisualizationRunner = new OverlapVisualizationRunner();
    }

    public BatchRunner getBatchRunner() {
        return batchRunner;
    }

    public PredefinedVisualizationRunner getPredefinedVisualizationRunner() {
        return predefinedVisualizationRunner;
    }

    public UnifiedVisualizationRunner getLinkedVisualizationRunner() {
        return linkedVisualizationRunner;
    }

    public OverlapVisualizationRunner getOverlapVisualizationRunner() {
        return overlapVisualizationRunner;
    }

    public void init() {
        predefinedVisualizationRunner.loadPredefinedFiles();
    }

}
