/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Dec 5, 2002
 * Time: 2:23:12 PM
 */

package EVolve.util.equators;

import EVolve.util.DataTrace;

public abstract class Equator implements Cloneable{
    protected String name;
    protected int interval;
    protected float percent;
    protected DataTrace trace;

    public Equator() {
        interval = 10;
        percent = 100;
    }

    public void setInterval(int interval) {
        this.interval = interval;
    }

    public void setMatch(float percent) {
        this.percent = percent;
    }

    public int getInterval() {
        return interval;
    }

    public float getMatch() {
        return percent;
    }

    public DataTrace getDataTrace() {
        return trace;
    }

    public abstract String getName();

    public abstract boolean isEqual(Set set1, Set set2);

    public abstract DataTrace initialDataTrace(int interval, int entityNumber);

    public Object clone() {
        Equator o = null;
        try {
            o = (Equator)super.clone();
        } catch (CloneNotSupportedException e) {
            e.printStackTrace();
            return null;
        }

        o.name = name;
        o.trace = (DataTrace)trace.clone();

        return o;
    }
}
