/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Jan 9, 2003
 * Time: 4:10:32 PM
 */
package EVolve.util.equators;

import java.util.ArrayList;


public class OrderedSet extends Set{

    public OrderedSet() {

    }

    public OrderedSet(int interval) {
        size = interval;
        data = new long[size];
        emptySlot = 0;
        entityNumber = 0;
        for (int i=0; i<size; i++)
            data[i] = -1;
    }

    public void addElement(long element) {
        if (emptySlot >= size) {
            System.out.println("Set is full, unable to add new elements!!!");
            return;
        }
        data[emptySlot] = element;
        emptySlot++;
    }

    public Set intersection(Set set) {
        ArrayList temp= new ArrayList();

        for (int i=0; i<size; i++) {
            if ((data[i]!=-1)&&(!temp.contains(new Long(data[i])))&&(set.exist(data[i])))
                temp.add(new Long(data[i]));
        }

        Set result = new OrderedSet(temp.size());
        for (int i=0; i<temp.size(); i++) {
            result.addElement(((Long)temp.get(i)).intValue());
        }

        return result;
    }

    public Set union(Set set) {
        ArrayList temp= new ArrayList();

        for (int i=0; i<size; i++) {
            if (!temp.contains(new Long(data[i])))
                temp.add(new Long(data[i]));
        }

        for (int i=0; i<set.size(); i++) {
            long element = set.getElement(i);
            if (!temp.contains(new Long(element)))
                temp.add(new Long(element));
        }

        Set result = new OrderedSet(temp.size());
        for (int i=0; i<temp.size(); i++) {
            result.addElement(((Long)temp.get(i)).longValue());
        }

        return result;
    }

    public boolean exist(long element) {
        for (int i=0; i<size; i++)
            if (data[i] == element) return true;

        return false;
    }

    public long getHashValue() {
        long retVal = data[0];
        ArrayList temp = new ArrayList();
        temp.add(new Long(data[0]));
        for (int i=1; i<size; i++) {
            if (!temp.contains(new Long(data[i])))
                retVal = retVal ^ data[i];
        }
        temp = null;

        return retVal;
    }

    public Set newSet() {
        return new OrderedSet(size);
    }

    public boolean equals(Set set, float percent) {
        float counter = 0;
        int loop = size>set.size() ? set.size() : size;

        for (int i = 0; i< loop; i++) {
            if (set.getElement(i) == data[i])
                counter ++;
        }

        return ((200*counter/(size+set.size())) >= percent) ;
    }

    public Object clone() {
        return super.clone();
    }
}
