/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Jan 9, 2003
 * Time: 4:22:21 PM
 */
package EVolve.util.equators;

public abstract class Set implements Cloneable{
    protected long [] data;
    protected int size;
    protected int emptySlot;
    protected int entityNumber;

    public int size() {
        return size;
    }

    public long getElement(int i) {
        return data[i];
    }

    public boolean setFull() {
        return emptySlot >= size;
    }

    public long getEntityId(int i) {
        return data[i];
    }

    public abstract void addElement(long element);

    public abstract Set intersection(Set set);

    public abstract Set union(Set set);

    public abstract boolean exist(long element);

    public abstract long getHashValue();

    public abstract Set newSet();

    public abstract boolean equals(Set set, float percent);

    public Object clone() {
        Set o = null;
        try {
            o = (Set)super.clone();
        } catch (CloneNotSupportedException e) {
            e.printStackTrace();
            return null;
        }

        o.data = new long[data.length];
        for (int i=0; i<data.length; i++)
            o.data[i] = data[i];
        return o;
    }
}
