/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Jan 9, 2003
 * Time: 10:16:34 PM
 */

package EVolve.util.equators;

import java.util.HashMap;
import java.util.Iterator;

public class UnorderedSet extends Set{
    private HashMap data;

    public UnorderedSet(int interval) {
        data = new HashMap();
        size = interval;
        emptySlot = 0;
    }

    public boolean exist(long element) {

        return data.containsKey(new Long(element));

    }

    public Set newSet() {
        return new UnorderedSet(size);
    }

    public long getElement(int index) {
        Iterator it = data.keySet().iterator();
        int i = 0;
        while (it.hasNext()) {
            Long key = (Long)it.next();
            if (i<index) continue;
            return key.longValue();
        }
        return -1;
    }

    public void addElement(long element) {
        if (emptySlot>=size) {
            System.out.println("Set is full, unable to add new elements!!!");
            return;
        }
        Long key = new Long(element);
        if (data.containsKey(key)) {
            Long value = (Long)data.get(key);
            data.put(key, new Long(value.longValue()+1));
        } else {
            data.put(key, new Long(1));
        }
        emptySlot++;
    }

    public Set union(Set set) {
        Set result = new UnorderedSet(size*2);
        HashMap setData[] = new HashMap[2];

        setData[0] = data;
        setData[1] = ((UnorderedSet)set).data;

        for (int i=0; i<setData.length; i++) {
            Iterator it = setData[i].keySet().iterator();
            while (it.hasNext()) {
                result.addElement(((Long)it.next()).longValue());
            }
        }

        return result;
    }

    public Set intersection(Set set) {
        HashMap setData[] = new HashMap[2];
        Set result = new UnorderedSet(size);

        setData[0] = data;
        setData[1] = ((UnorderedSet)set).data;

        Iterator it = setData[0].keySet().iterator();
        while (it.hasNext()) {
            Long key = (Long)it.next();
            if (setData[1].containsKey(key))
                result.addElement(key.longValue());
        }

        return result;
    }

    public boolean equals(Set set, float percent) {
        float counter = 0;
        HashMap setData[] = new HashMap[2];

        setData[0] = data;
        setData[1] = ((UnorderedSet)set).data;

        Iterator it = setData[0].keySet().iterator();
        while (it.hasNext()) {
            Long key = (Long)it.next();
            if (setData[1].containsKey(key))
                counter = counter + ((Long)setData[0].get(key)).longValue()+((Long)setData[1].get(key)).longValue();
        }

        return ((100*counter/(2*size)) >= percent);
    }

    public long getHashValue() {
        long result = 0;


        Iterator it = data.keySet().iterator();
        while (it.hasNext()) {
            Long key = (Long)it.next();
            result = result ^ key.intValue();
        }

        return result;
    }

    public long getEntityId(int i) {
        if (data.size() == 0)
            return -1;

        Iterator it = data.keySet().iterator();

        return ((Long)it.next()).longValue();
    }

    public Object clone() {
        return super.clone();
    }
}
