/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Apr 1, 2003
 * Time: 8:03:20 PM
 */

package EVolve.util.equators;

import java.util.HashMap;
import java.util.Iterator;

import EVolve.util.HelperFuncs;

public class UnorderedUnlimitedSet extends Set{
    private HashMap data;

    public UnorderedUnlimitedSet() {
        data = new HashMap();
    }

    public int size() {
        return data.size();
    }

    public long getElement(int i) {
        return ((Long)data.get(new Integer(i))).longValue();
    }

    public boolean setFull() {
        return false;
    }

    public long getEntityId(int i) {
        return getElement(i);
    }

    public void addElement(long id) {
        if (!data.containsValue(new Long(id)))
            data.put(new Integer(data.size()),new Long(id));
    }

    public Set newSet() {
        return new UnorderedUnlimitedSet();
    }

    public Set union(Set set) {
        Set result = new UnorderedUnlimitedSet();
        HashMap setData[] = new HashMap[2];

        setData[0] = data;
        setData[1] = ((UnorderedUnlimitedSet)set).data;

        for (int i=0; i<setData.length; i++) {
            Iterator it = setData[i].keySet().iterator();
            while (it.hasNext()) {
                result.addElement(((Long)setData[i].get(it.next())).longValue());
            }
        }

        return result;
    }

    public Set intersection(Set set) {
        HashMap otherData = ((UnorderedUnlimitedSet)set).data;
        Set result = new UnorderedUnlimitedSet();

        Iterator it = data.keySet().iterator();
        while (it.hasNext()) {
            Long value = (Long)data.get(it.next());
            if (otherData.containsValue(value))
                result.addElement(value.longValue());
        }

        return result;
    }

    public boolean exist(long element) {
        return data.containsValue(new Long(element));
    }

    public boolean equals(Set set, float percent) {
        Set union = union(set);
        Set intersection = intersection(set);

        return ((float)intersection.size()/(float)union.size()) >= percent;

    }

    public float getOrderedMatch(UnorderedUnlimitedSet next) {
        HashMap source = data, target = next.data;
        Iterator it = source.keySet().iterator();
        int accum = 0, count = 0;
        float result;

        while (it.hasNext()) {
            Long mappedId = (Long)source.get(it.next());
            //if (target.containsValue(mappedId)) continue;
            accum += mappedId.intValue();
            count++;
        }
        result = (float)accum/(float)count;

        accum = count = 0;
        it = target.keySet().iterator();
        while (it.hasNext()) {
            Long mappedId = (Long)target.get(it.next());
            //if (source.containsValue(mappedId)) continue;
            accum += mappedId.intValue();
            count++;
        }
        result = Math.abs(result - (float)accum/(float)count);

        return result;
    }

    public long getMaxEntityId() {
        int maxId = 0;

        Iterator it = data.keySet().iterator();
        while (it.hasNext()) {
            Long mappedId = (Long)data.get(it.next());
            if (maxId < mappedId.intValue())
                maxId = mappedId.intValue();
        }
        return maxId;
    }

    public long getHashValue() {
        return 0;
    }

    public Object clone() {
        UnorderedUnlimitedSet o = (UnorderedUnlimitedSet)super.clone();
        o.data = HelperFuncs.cloneHashMap(data);

        return o;
    }
}
