/*
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: 2002-9-6
 * Time: 15:53:41
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package EVolve.util.overlappers;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.filechooser.FileSystemView;

import EVolve.Scene;
import EVolve.exceptions.EVolveException;
import EVolve.exceptions.NoDataPlotException;
import EVolve.util.predefinedutils.VisualizationSerializer;
import EVolve.util.xmlutils.datastructures.SerializedVisualization;
import EVolve.util.xmlutils.datastructures.SerializedData;
import EVolve.util.unifyutils.Unification;
import EVolve.visualization.ReferenceDimension;
import EVolve.visualization.Visualization;
import EVolve.visualization.XYViz.XYVisualization;

public class AsynchronousOverlapper extends OverlapVisualization {
    private final String name = "AsynchronousOverlapper";
    private JList fileList,procList;
    private JTextField txtConfName;
    private HashSet setFile;
    private ArrayList setProcessFiles;
    private DefaultListModel procListModel,fileListModel;
    private ArrayList[] entityList;
    private ArrayList[] referenceDimList;

    public AsynchronousOverlapper() {
        super();
        dialog = null;
        setProcessFiles = new ArrayList();
        setFile = new HashSet();
        colorList = new ArrayList();
        entityList = new ArrayList[2];
        entityList[0] = new ArrayList();
        entityList[1] = new ArrayList();
        referenceDimList = new ArrayList[2];
        referenceDimList[0] = new ArrayList();
        referenceDimList[1] = new ArrayList();
    }

    public String getName() {
        return name;
    }

    public void createDialog() {
        setFile.clear();
        setProcessFiles.clear();
        colorList.clear();
        visualizationList.clear();
        dialog = new JDialog(Scene.getFrame(),"Overlap Visualizations...",true);
        dialog.setBounds(new Rectangle(500,400));

        JPanel batchName = new JPanel(new FlowLayout());
        dialog.getContentPane().add(batchName,BorderLayout.NORTH);

        Box boxMain = new Box(BoxLayout.Y_AXIS);
        boxMain.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),
                "Choose data source(s) to be overlapped & Processing configuration"));
        dialog.getContentPane().add(boxMain,BorderLayout.CENTER);


        Box boxLabels = new Box(BoxLayout.X_AXIS);
        JButton buttonGetDir = new JButton("Select Directory ..");
        buttonGetDir.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                    fillFileList();
            }
        });
        boxLabels.add(buttonGetDir);
        boxLabels.add(Box.createHorizontalGlue());
        boxLabels.add(new JLabel("Processing List                             "));

        Box boxLists = new Box(BoxLayout.X_AXIS);
        fileListModel = new DefaultListModel();
        fileList = new JList(fileListModel);

        Box boxAddRemove = new Box(BoxLayout.Y_AXIS);
        JButton buttonAdd = new JButton("  >  ");
        buttonAdd.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                addFiles();
            }
        });
        JButton buttonRemove = new JButton("  <  ");
        buttonRemove.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                removeFiles();
            }
        });
        boxAddRemove.add(Box.createVerticalStrut(40));
        boxAddRemove.add(buttonAdd);
        boxAddRemove.add(Box.createVerticalStrut(20));
        boxAddRemove.add(buttonRemove);

        procListModel = new DefaultListModel();
        procList = new JList(procListModel);

        JScrollPane scrollPane1 = new JScrollPane(fileList);
        JScrollPane scrollPane2 = new JScrollPane(procList);
        boxLists.add(scrollPane1);
        boxLists.add(boxAddRemove);
        boxLists.add(scrollPane2);

        boxMain.add(boxLabels);
        boxMain.add(Box.createVerticalStrut(5));
        boxMain.add(boxLists);

        Box boxConfig = new Box(BoxLayout.X_AXIS);
        boxConfig.add(new JLabel("Choose configure file:"));
        txtConfName = new JTextField(12);
        boxConfig.add(Box.createHorizontalStrut(20));
        boxConfig.add(txtConfName,BorderLayout.CENTER);
        JButton buttonConfig = new JButton("...");
        buttonConfig.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                txtConfName.setText(chooseConfig());
            }
        });
        boxConfig.add(buttonConfig,BorderLayout.EAST);

        Box boxOkCancel = new Box(BoxLayout.X_AXIS);
        JButton buttonOK = new JButton("OK");
        JButton buttonCancel = new JButton("Cancel");
        JButton buttonColor = new JButton("Coloring");

        buttonOK.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                onOK();
            }
        });
        buttonCancel.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                onCancel();
            }
        });
        buttonColor.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                selectColor();
            }
        });

        boxOkCancel.add(Box.createHorizontalStrut(25));
        boxOkCancel.add(buttonColor);
        boxOkCancel.add(Box.createHorizontalStrut(20));
        boxOkCancel.add(buttonOK);
        boxOkCancel.add(Box.createHorizontalStrut(20));
        boxOkCancel.add(buttonCancel);

        Box boxBottom = Box.createVerticalBox();
        boxBottom.add(Box.createVerticalStrut(12));
        boxBottom.add(boxConfig);
        boxBottom.add(Box.createVerticalStrut(30));
        boxBottom.add(boxOkCancel);


        dialog.getContentPane().add(boxBottom,BorderLayout.SOUTH);
        //dialog.setResizable(false);

    }

    private void selectColor() {
        int index = procList.getSelectedIndex();

        if (index != -1) {
            Color newColor = JColorChooser.showDialog(Scene.getFrame(), "Choose a color", Color.black);
            if (newColor != null) {
                colorList.add(index,newColor);
                colorList.remove(index+1);
                procListModel.removeAllElements();

                for (int i=0; i<setProcessFiles.size(); i++) {
                    if (colorList.get(i) == null)
                        procListModel.addElement(setProcessFiles.get(i));
                    else
                        procListModel.addElement("<html><font color=#" + getColorHex((Color)colorList.get(i)) + ">"
                                             + setProcessFiles.get(i) +" </font></html>" );
                }
            }
        }
    }

    private void onOK() {

        if (procListModel.size() < 2) {
           Scene.showErrorMessage("Please select at least 2 data source.");
           return;
        }

        if (txtConfName.getText().trim().length() == 0) {
            Scene.showErrorMessage("No configuration file selected!");
            return;
        }
        dialog.setVisible(false);
        noEntityAvailable = false;

        overlappedVisualize();
    }

    private void onCancel() {
        dialog.setVisible(false);
    }

    private void addFiles() {
        int[] selectIndex = fileList.getSelectedIndices();
        ArrayList newColorList = new ArrayList();

        for (int i=0;i<selectIndex.length;i++) {
            if (setProcessFiles.contains(fileListModel.getElementAt(selectIndex[i]))) continue;

            setProcessFiles.add(fileListModel.getElementAt(selectIndex[i]));
            procListModel.addElement(fileListModel.getElementAt(selectIndex[i]));
        }

        for (int i=0; i<setProcessFiles.size();i++) {
            if (i<colorList.size())
                newColorList.add(i,colorList.get(i));
            else
                newColorList.add(i,null);
        }
        colorList = newColorList;
    }

    private void removeFiles() {
        int[] selectIndex = procList.getSelectedIndices();

        for (int i=selectIndex.length -1 ;i>=0;i--) {
            setProcessFiles.remove(selectIndex[i]);
            colorList.remove(selectIndex[i]);
            procListModel.removeElement(procListModel.getElementAt(selectIndex[i]));
        }
    }

    private String chooseConfig() {
        JFileChooser fc = new JFileChooser(Scene.getUIManager().getLastConfigDir());

        if(fc.showOpenDialog(Scene.getFrame()) == JFileChooser.APPROVE_OPTION) {
            File f = fc.getSelectedFile();
            Scene.getUIManager().setLastConfigDir(f.getPath());
            return (f.getPath());
        }
        else return "";
    }

    private void fillFileList() {
        JFileChooser fc = new JFileChooser(Scene.getUIManager().getLastDataDir());
        String path;

        fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

        fileListModel.removeAllElements();
        if(fc.showOpenDialog(Scene.getFrame()) == JFileChooser.APPROVE_OPTION) {
            path = fc.getSelectedFile().getAbsolutePath();
            Scene.getUIManager().setLastDataDir(path);
            File dir = new File(path);
            FileSystemView fv = fc.getFileSystemView();
            File[] fl = fv.getFiles(dir,false);
            for (int i=0;i<fl.length;i++) {
                String fn = fl[i].getName();
                if (!fl[i].isFile() || !fn.endsWith(".dat") || setFile.contains(path+File.separator+fn))
                    continue;
                setFile.add(path+File.separator+fn);
                fileListModel.addElement(path+File.separator+fn);
            }
        }

    }

    public boolean isOverlapable(Visualization visualToBeOverlapped) {
        return true;
    }

    public void preOverlappedVisualize() throws EVolveException{
        String dataSource;
        SerializedVisualization vizInfo = null;
        Visualization visual;

        reset();
        for (int i=0; i<procListModel.size(); i++) {
            dataSource = (String)setProcessFiles.get(i);
            Scene.setDataFilename(dataSource);
            Scene.autoLoadDataSource();

            if (i == 0) {
                SerializedData data = VisualizationSerializer.v().getVizInfoFromDisk(txtConfName.getText().trim());
                vizInfo = (SerializedVisualization)data.SerializedVisualizations.get(0);
            }

            visual = Scene.getVisualizationManager().newVisualization(vizInfo.FactoryName);

            visual.setName(vizInfo.VisualizationName);
            visual.restoreConfiguration(vizInfo);
            visualizationList.add(visual);

            Scene.getVisualizationManager().addAllVisualizations();
            Scene.getVisualizationManager().prepareListToBeVisualized();
            Scene.autoVisualize();

            for (int k=0; k< entityList.length; k++)
                if (visual.getDimension()[k] instanceof ReferenceDimension) {
                    entityList[k].add(Scene.getDataManager().getEntity()[visual.getDimension()[k].getDataFilter().getTargetType()]);
                    referenceDimList[k].add(visual.getDimension()[k]);
                }
        }

    }

    public void overlappedVisualize() {
        Visualization visual;

        Scene.getVisualizationManager().init();
        Scene.getUIManager().init();

        if (window instanceof EVolve.Window) {
            Scene.getUIManager().removeWindow(window);
            window = null;
        }
        visualizationList.clear();
        Scene.getUIManager().setDoNotRemoveWindow(true);
        try {
            preOverlappedVisualize();
        } catch (EVolveException e) {
            Scene.showErrorMessage(e.getMessage());
            Scene.getUIManager().setDoNotRemoveWindow(false);
            Scene.setDataFilename(null);
            return;
        }
        Scene.getUIManager().setDoNotRemoveWindow(false);
        Scene.setDataFilename(null);


        unifyVisualizations();

        // begin drawing overlap
        if (window instanceof EVolve.Window) {
            Scene.getUIManager().removeWindow(window);
            window = null;
        }

        newOverlappedVisualization(this);

        int [] selectedIndex = new int[2];
        int [] sortedDimension = new int[2];
        visual = (Visualization)visualizationList.get(0);

        for (int i=0; i<fullEntitySet.length; i++) {
            if (visual.getDimension()[i] instanceof ReferenceDimension) {

                selectedIndex[i] = ((ReferenceDimension)visual.getDimension()[i]).getSelectedComparatorIndex();
                sortedDimension[i] = 1;
                break;
            }
        }

        sort();
        enableSortMenu();
    }

    private void unifyVisualizations() {
        // now we begin unify all entities
        HashMap standard[] = new HashMap[2];
        standard[0] = new HashMap();
        standard[1] = new HashMap();

        for (int i=0; i<entityList.length; i++) {
            for (int j=0; j<entityList[i].size(); j++) {
                Unification.unifyEntities(standard[i],(HashMap)entityList[i].get(j));
            }
        }

        // dump the unified entities into a hashset
        for (int i=0; i<standard.length; i++) {
            Iterator it = standard[i].keySet().iterator();
            fullEntitySet[i] = new HashSet();
            while (it.hasNext()) {
                fullEntitySet[i].add(standard[i].get(it.next()));
            }
        }
        // unifying entities done here

        Visualization visual;
        for (int i=0; i<entityList.length; i++) {
            if (entityList[i].size() == 0) continue; // not a reference dimension
            for (int j=0; j<visualizationList.size(); j++) {
                visual = (Visualization)visualizationList.get(j);

                ReferenceDimension dim = visual.getLinkableDimension(i);
                Color newColor = (Color)colorList.get(j);
                Unification.changeColor(visual.getImage(),newColor);

                dim.linkEntities(fullEntitySet[i]);
                try {
                    dim.visualize();
                } catch (NoDataPlotException e) {
                    Scene.showErrorMessage(e.getMessage());
                }
                ((XYVisualization)visual).disablePopupMenu();
            }
        }
    }

    private void reset() {
        fullEntitySet = new HashSet[2];
        fullEntitySet[0] = null;
        fullEntitySet[1] = null;
        for (int i= 0; i<entityList.length ; i++) {
            entityList[i].clear();
        }
    }
}
