/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Nov 29, 2002
 * Time: 12:57:16 AM
 */

package EVolve.util.painters;

import java.awt.Color;

import EVolve.visualization.AutoImage;

public class CorrelationPainter extends Painter{
    private int [][] value;

    public CorrelationPainter(int[][] value) {
        this.value = value;
    }

    public String getName() {
        return "Correlation Painter";
    }

    public void paint(AutoImage image, long x, long y, long z) {
        for (int i = 0; i < value.length; i++) {
            for (int j = 0; j < value[i].length; j++) {
                if (value[i][j] != 0) {
                    //Color color = new Color((int)(value[i][j] * 255 / z), 0, (int)(255 - value[i][j] * 255 / z));
                    image.setColor(i, j, Color.black);
                }
            }
        }
    }

    public Object clone() {
        CorrelationPainter o = (CorrelationPainter)super.clone();
        o.value = new int[value.length][];
        for (int i=0; i<value.length; i++) {
            o.value[i] = new int[value[i].length];
            for (int j=0; j<value[i].length; j++)
                o.value[i][j] = value[i][j];
        }
        return o;
    }
}
