/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Feb 24, 2003
 * Time: 4:18:16 PM
 */

package EVolve.util.painters;

import EVolve.visualization.AutoImage;
import EVolve.visualization.Predictor;

public class EventPredictionPainter extends PredictionPainter{
    private int lineWidth;

    public void paint(AutoImage image, long x, long y, long z) {
        int X = (int)(x%lineWidth), Y= (int)(x/lineWidth);
        predictor[(int)y].newTarget(z);

        if (validateTarget(y,z)) {
            if (predictor[(int)y].isCorrect()) {
                if (image.getColor(X, Y) == null) {
                    image.setColor(X, Y, colorBlue);
                }
            } else {
                image.setColor(X, Y, colorRed);
                miss[(int)y]++;
            }
        } else {
            if (image.getColor(X, Y) == null) {
                image.setColor(X, Y, colorBlue);
            }
        }
    }

    public void setParameters(Predictor[] predictor, int targetType, int lineWidth) {
        setPredictor(predictor,targetType);
        this.lineWidth = lineWidth;
    }

}
