/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Dec 1, 2002
 * Time: 2:09:10 AM
 */

package EVolve.util.painters;

import EVolve.visualization.AutoImage;
import EVolve.visualization.Predictor;

public class MissRatePainter extends PredictionPainter{
    private long predictCounter, hitCounter, lastX;
    private float maxMiss = 0;

    public MissRatePainter(Predictor[] predictor,int targetType) {
        super(predictor,targetType);
        predictCounter = 0;
        hitCounter = 0;
        lastX = 0;
        maxMiss = 0;
    }

    public String getName() {
        return "Miss Prediction Metric Painter";
    }

    public void paint(AutoImage image, long x, long y, long z) {
        predictor[(int)y].newTarget2(z);

        if (x>=miss.length) {
            int [] newmetrics = new int[miss.length+200];
            for (int i =0; i< newmetrics.length; i++)
                if (i<miss.length)
                    newmetrics[i] = miss[i];
                else newmetrics[i] = 0;
            miss = newmetrics;
        }

        if (x != lastX) {
            if (predictCounter != 0)
                miss[(int)lastX] = (int)(300*(predictCounter - hitCounter)/predictCounter);
            if (maxMiss < (float)miss[(int)lastX]/300) {
                maxMiss = (float)miss[(int)lastX]/300;
            }
            for (int i = (int)lastX; i<x; i++)
            {
                miss[i] = miss[(int)lastX];
                if (miss[(int)lastX] != 0)
                    image.setColor(i,miss[(int)lastX],colorRed);
            }
            lastX = x;
        }
        if (validateTarget(y,z)) {
            predictCounter++;
            if (predictor[(int)y].isCorrect()) {
                hitCounter ++;
            }
        }
    }

    public float getMaxMiss() {
        return maxMiss;
    }

    public float getMissrate(int X) {
        return ((float)miss[X])/3;
    }
}
