/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Nov 30, 2002
 * Time: 4:06:04 PM
 */

package EVolve.util.painters;

import java.awt.Color;

import EVolve.util.ColorCache;
import EVolve.visualization.AutoImage;

public class RandomPainter extends Painter{
    protected ColorCache colorCache;

    public RandomPainter() {
        colorCache = new ColorCache();
    }

    public String getName() {
        return "Random Color Painter";
    }

    public void paint(AutoImage image, long x, long y, long z) {
        image.setColor((int)x,(int)y,colorCache.getNextColor(z));
    }

    public long getKeyFromColor(Color color) {
        return colorCache.getKeyFromColor(color);
    }

    public Object clone()  {
        RandomPainter o = (RandomPainter)super.clone();
        o.colorCache = (ColorCache)colorCache.clone();
        return o;
    }
}
