/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Nov 28, 2002
 * Time: 3:12:09 AM
 */

package EVolve.util.painters;

import java.awt.Color;
import java.util.Stack;

import EVolve.visualization.AutoImage;

public class StackHotspotPainter extends Painter{
    private Stack currentStack;

    public String getName() {
        return "Stack Hotspot Painter";
    }

    public void paint(AutoImage image, long x, long y, long z) {

        if (z == Integer.MAX_VALUE) {// method return;
            image.setColor((int)x,(int)y,Color.black);
            if (!currentStack.empty()) {
                currentStack.pop();
                if (!currentStack.empty()) {
                    image.setColor((int)x,((Long)currentStack.peek()).intValue(),Color.red );
                }
            }
        } else {
            for (int i=0; i<currentStack.size(); i++) {
                image.setColor((int)x,((Long)currentStack.get(i)).intValue(),Color.blue);
            }
            image.setColor((int)x,(int)y,Color.red);
            currentStack.push(new Long(y));
        }
    }

    public void setStack(Stack stack) {
        currentStack = stack;
    }

    public Object clone() {
        StackHotspotPainter o = (StackHotspotPainter)super.clone();
        o.currentStack = (Stack)currentStack.clone();
        return o;
    }
}
