/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Dec 11, 2002
 * Time: 8:19:43 PM
 */

package EVolve.util.painters;

import java.util.HashMap;

import EVolve.util.ThreadChooser;
import EVolve.visualization.AutoImage;

public class ThreadHotspotPainter extends DefaultPainter{
    private HashMap imageMap;

    public ThreadHotspotPainter() {
    }

    public ThreadHotspotPainter(HashMap imageMap) {
        this.imageMap = imageMap;
    }

    public String getName() {
        return "Thread Hotspot Painter";
    }

    public AutoImage getImage() {
        AutoImage image;

        ThreadChooser thd = new ThreadChooser(imageMap,true);
        thd.showDialog();
        image = thd.coloringImages(imageMap);

        return image;
    }

    public void setImageMap(HashMap imageMap) {
        this.imageMap = imageMap;
    }

    public Object clone() {
        ThreadHotspotPainter o = (ThreadHotspotPainter)super.clone();
        o.imageMap = (HashMap)imageMap.clone();
        return o;
    }
}

