/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Feb 26, 2003
 * Time: 7:58:18 PM
 */

package EVolve.util.painters.placements;

import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.HashMap;

import EVolve.exceptions.NoDataPlotException;
import EVolve.util.painters.shapes.Shape;
import EVolve.visualization.AutoImage;

public abstract class Placement{
    public static final int INDENT = 50;
    protected int shapeSize = 10;
    protected HashMap parties[];

    public Placement() {
        parties = new HashMap[2];
    }

    public void categorize(AutoImage image, int consumer_type) {
        int w = image.getW(), h = image.getH();

        parties[0] = new HashMap();
        parties[1] = new HashMap();

        for (int j=0; j<h; j++) {
            for (int i=0; i<w; i++) {
                Object value = image.getColor(i,j);
                if (value == null) continue;
                for (int k=0; k<((ArrayList)value).size(); k++) {
                    Shape consumer = (Shape)((ArrayList)value).get(k);
                    if (consumer.getEntityType() == consumer_type) {
                        parties[1].put(new Integer(parties[1].size()),consumer);
                        break;
                    }
                }
            }
        }


        for (int i=0; i<w; i++) {
            for (int j=0; j<h; j++) {
                Object value = image.getColor(i,j);
                if (value == null) continue;
                for (int k=0; k<((ArrayList)value).size(); k++) {
                    Shape producer = (Shape)((ArrayList)value).get(k);
                    if (producer.getEntityType() != consumer_type) {
                        parties[0].put(new Integer(parties[0].size()),producer);
                        break;
                    }
                }
            }
        }

    }

    public abstract String getName();

    public abstract Rectangle initialPlacement(AutoImage image) throws NoDataPlotException;
}
