/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Feb 26, 2003
 * Time: 7:57:04 PM
 */

package EVolve.util.painters.placements;

import java.awt.Rectangle;

import EVolve.exceptions.NoDataPlotException;
import EVolve.util.painters.shapes.Shape;
import EVolve.visualization.AutoImage;

public class RectPlacement extends Placement{

    public RectPlacement(int shapeSize) {
        super();
        this.shapeSize = shapeSize;
    }

    public String getName() {
        return "Rectangle Placement";
    }

    public Rectangle initialPlacement(AutoImage image) throws NoDataPlotException{
        int totalShapes = parties[0].size() + parties[1].size();
        int startX, startY, delta;
        int objectInLines = 0;

        if (parties[0] == parties[1]) totalShapes /= 2;

        startX = startY = INDENT;
        delta = 30;

        int i = 0,producerSize = parties[0].size();

        if (producerSize == 0) throw new NoDataPlotException();

        while (i<totalShapes) {
            for (int j=0; j<parties[i/producerSize].size(); j++) {
                Shape object = (Shape)parties[i/producerSize].get(new Integer(j));
                object.move(startX+j*delta-shapeSize/2,startY-shapeSize/2);
            }
            if (objectInLines < parties[i/producerSize].size())
                objectInLines = parties[i/producerSize].size();
            i += parties[i/producerSize].size();
            startY = INDENT + 350;
        }
        Rectangle bounds = new Rectangle();
        bounds.height = 2*(INDENT + shapeSize)+350;
        bounds.width = shapeSize + delta * (objectInLines - 1) + INDENT*2;

        image.setImageSize(bounds.width, bounds.height);
        return bounds;
    }
}
