/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Feb 26, 2003
 * Time: 7:57:30 PM
 */

package EVolve.util.painters.placements;

import java.awt.Rectangle;

import EVolve.util.painters.shapes.Shape;
import EVolve.visualization.AutoImage;

public class RoundPlacement extends Placement{

    public RoundPlacement(int shapeSize) {
        super();
        this.shapeSize = shapeSize;
    }

    public String getName() {
        return "Round Placement";
    }

    public Rectangle initialPlacement(AutoImage image) {
        int totalShapes = parties[0].size() + parties[1].size();
        int startX, startY;
        double angle, radius, delta, x, y;

        if (parties[0] == parties[1]) totalShapes /= 2;

        radius = shapeSize/(Math.sin(Math.PI/totalShapes));
        startX = startY = (int)radius+INDENT;
        angle = 0;
        delta = 2*Math.asin(shapeSize/radius);

        int i = 0,producerSize = parties[0].size();
        while (i<totalShapes) {
            for (int j=0; j<parties[i/producerSize].size(); j++) {
                Shape object = (Shape)parties[i/producerSize].get(new Integer(j));
                x = startX + radius * Math.cos(angle);
                y = startY + radius * Math.sin(angle);
                object.move((int)x-shapeSize/2,(int)y-shapeSize/2);
                angle += delta;
            }
            i += parties[i/producerSize].size();
        }
        Rectangle bounds = new Rectangle();
        bounds.height = bounds.width = (int)(radius * 2 + shapeSize + INDENT*2);

        image.setImageSize(bounds.width, bounds.height);

        return bounds;
    }

}
