/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Feb 14, 2003
 * Time: 9:35:02 PM
 */

package EVolve.util.painters.shapes;

import java.awt.Graphics2D;

public class Ball extends Shape{
    private int diameter;

    public Ball(long entity_type, long entity_id, int diameter) {
        super(entity_type,entity_id);
        this.entity_type = entity_type;
        this.diameter = diameter;
    }

    public String getName() {
        return "Box";
    }

    public void draw(Graphics2D g) {
        if (color != null) {
            g.setColor(color);
        } else {
            g.setColor(defaultColor);
        }
        g.drawOval(x,y,diameter,diameter);

        if (consumerMap == null) return;

        drawArrows(g);
    }

    public void fill(Graphics2D g) {
        if (color != null) g.fillOval(x,y,diameter,diameter);
    }

    public boolean insideShape(int x, int y) {
        if ((x<=this.x+diameter) && (x>=this.x) &&
            (y<=this.y+diameter) && (y>=this.y))
            return true;
        return false;
    }

    public int getWidth() {
        return diameter;
    }

    public int getHeight() {
        return diameter;
    }

    public void setSize(int width, int height) {
        diameter = width;
    }
}
