/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Feb 27, 2003
 * Time: 1:27:26 PM
 */

package EVolve.util.painters.shapes;

import java.awt.Graphics2D;

public class Line extends Shape implements Cloneable{
    private int lastX, lastY, size;

    public Line(long entity_type, long entity_id, int size) {
        super(entity_type, entity_id);
        lastX = lastY = -1;
        this.size = size;
    }

    public void draw(Graphics2D g) {
        if (color != null) g.setColor(color);

        if (lastX == -1)
            g.drawLine(x,y,x,y);
        else
            g.drawLine(lastX,lastY,x,y);
        lastX = x;
        lastY = y;
    }

    public void fill(Graphics2D g) {
    }

    public String getName() {
        return "Line";
    }

    public boolean insideShape(int x, int y) {
        return false;
    }

    public int getWidth() {
        return size;
    }

    public int getHeight() {
        return size;
    }

    public void setSize(int width, int height) {
        size = width;
    }

    public Object clone() {
        Line o = (Line)super.clone();

        o.lastX = -1;
        o.lastY = -1;
        return o;
    }
}
