/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Apr 27, 2003
 * Time: 1:14:55 PM
 */

package EVolve.util.phasedetectors;

import java.awt.Cursor;
import java.awt.Point;

import javax.swing.JPanel;
import javax.swing.JScrollPane;

import EVolve.Scene;
import EVolve.util.HelperFuncs;
import EVolve.visualization.AxesPanel;
import EVolve.visualization.XYViz.XYVisualization;

public class PhaseAddRemover extends Thread{
    private XYVisualization workingViz;
    private boolean bAdding;

    public void beginAdd() {
        this.bAdding = true;
        start();
    }

    public void beginRemove() {
        this.bAdding = false;
        start();
    }

    public void run() {
        workingViz = HelperFuncs.getActiveXYViz();

        if (workingViz == null) return;

        Scene.getUIManager().enablePhaseDetectorButton(false);

        workingViz.freeze(true);
        AxesPanel canvas = (AxesPanel)((JScrollPane)workingViz.getPanel()).getViewport().getView();
        setCursor(canvas, false);

        while (workingViz.isFreezed()) {
            try {
                sleep(100);
            } catch (InterruptedException e) {
                break;
            }
        }

        setCursor(canvas, true);
        int newPhase = getPhaseUnderMouse();

        if (newPhase >= 0) {
            if (bAdding)
                workingViz.getPhaseDetector().addPhaseManually(newPhase+1);
            else
                workingViz.getPhaseDetector().removePhaseManually(newPhase+1);
        }

        Scene.getUIManager().enablePhaseDetectorButton(true);
    }

    private void setCursor(JPanel panel, boolean reset) {
        if (reset)
            panel.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        else
            panel.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
    }

    private int getPhaseUnderMouse() {
        XYVisualization visual = HelperFuncs.getActiveXYViz();

        if (visual == null) {
            return -1;
        }

        Point pt = visual.getMousePosition();
        AxesPanel canvas = (AxesPanel)((JScrollPane)visual.getPanel()).getViewport().getView();

        return canvas.getImageX(pt.x);
    }
}
