/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: May 17, 2003
 * Time: 8:29:55 PM
 */

package EVolve.util.phasedetectors;

import java.util.ArrayList;
import java.util.HashMap;

import EVolve.Scene;
import EVolve.data.Entity;
import EVolve.data.Selection;
import EVolve.util.equators.UnorderedUnlimitedSet;
import EVolve.visualization.ReferenceDimension;
import EVolve.visualization.XYViz.ValRefViz.HotSpotViz.HotSpotVisualization;

public class PhaseEntitySet {
    private UnorderedUnlimitedSet trigger;
    private int state[];
    private final int setFound = 1;

    public PhaseEntitySet() {
    }

    public ArrayList gatherTiggeredPhase(ArrayList data, int noiseTolerance, float threshold) {
        ArrayList phase = new ArrayList();
        Selection activeSelection = Scene.getFilter().getActiveSelection();

        if (activeSelection == null) {
            Scene.showErrorMessage("No active selection.");
            return phase;
        }

        state = new int[data.size()];
        for (int i=0; i<state.length; i++) {
            state[i] = 0;
        }

        HotSpotVisualization visual = (HotSpotVisualization)Scene.getVisualizationManager().getActiveVisualization();
        HashMap entityName2Int = ((ReferenceDimension)visual.getDimension()[1]).getEntityName2IntMap();
        trigger = new UnorderedUnlimitedSet();

        Entity[] entities = activeSelection.getSelected();
        for (int i=0; i<entities.length; i++) {
            int mappedId = ((Integer)entityName2Int.get(entities[i].getName())).intValue();
            trigger.addElement(mappedId);
        }


        //float rates[] = new float[data.size()];
        int previous = 0;
        for (int i=0; i<data.size(); i++) {
            UnorderedUnlimitedSet current = (UnorderedUnlimitedSet)data.get(i);
            float rate = ((float)current.intersection(trigger).size())/(float)trigger.size();//((float)union.union(current).size());
            if (rate >= threshold ) {
                state[i] = setFound;
            } else {
                if (rate == 0) {
                    state[i] = 0;
                } else {
                    state[i] = previous;
                }
            }
            previous = state[i];
        }

        previous = state[0];
        int noise = 0;
        for (int i=1; i<state.length; i++) {
            if (state[i] != previous) {
                noise ++;
                if (noise > noiseTolerance) {
                    if (previous == setFound)
                        phase.add(new Integer(i-noise+1));
                    previous = state[i];
                    noise = 0;
                } else {
                    if (state[i] == setFound) {
                        phase.add(new Integer(i));
                        previous = setFound;
                        noise = 0;
                    }
                }
            } else {
                noise = 0;
            }
        }

        return phase;
    }
}
