/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Apr 24, 2003
 * Time: 9:56:40 PM
 */

package EVolve.util.phasedetectors;

import java.util.ArrayList;
import java.util.HashMap;

import EVolve.Scene;
import EVolve.data.Entity;
import EVolve.data.Selection;
import EVolve.util.equators.UnorderedUnlimitedSet;
import EVolve.visualization.ReferenceDimension;
import EVolve.visualization.XYViz.ValRefViz.HotSpotViz.HotSpotVisualization;

public class PhaseEntityTrigger {
    private UnorderedUnlimitedSet trigger;
    private int state[];
    private final int triggerFound = 1;

    public PhaseEntityTrigger() {
    }

    public ArrayList gatherTiggeredPhase(ArrayList data, int noiseTolerance, float threshold) {
        ArrayList phase = new ArrayList();
        Selection activeSelection = Scene.getFilter().getActiveSelection();

        if (activeSelection == null) {
            Scene.showErrorMessage("No active selection.");
            return phase;
        }

        state = new int[data.size()];
        for (int i=0; i<state.length; i++) {
            state[i] = 0;
        }

        HotSpotVisualization visual = (HotSpotVisualization)Scene.getVisualizationManager().getActiveVisualization();
        HashMap entityName2Int = ((ReferenceDimension)visual.getDimension()[1]).getEntityName2IntMap();
        trigger = new UnorderedUnlimitedSet();

        Entity[] entities = activeSelection.getSelected();
        for (int i=0; i<entities.length; i++) {
            int mappedId = ((Integer)entityName2Int.get(entities[i].getName())).intValue();
            trigger.addElement(mappedId);
        }


        for (int i=0; i<data.size(); i++) {
            UnorderedUnlimitedSet current = (UnorderedUnlimitedSet)data.get(i);

            if (((float)current.intersection(trigger).size())/((float)trigger.size()) >= threshold ) {
                state[i] = triggerFound;
            }
        }

        int previous = state[0], noise = 0;
        for (int i=1; i<state.length; i++) {
            if (state[i] != previous) {
                noise ++;
                if (noise > noiseTolerance) {
                    if (previous == triggerFound)
                        phase.add(new Integer(i-noise));
                    else
                        phase.add(new Integer(i-noise+1));
                    noise = 0;
                    previous = state[i];
                }
            } else {
                noise = 0;
            }
        }
        /*int noise = 0;
        for (int i=0; i<state.length; i++) {
            if (state[i] == triggerFound) {
                noise ++;
                if (noise > noiseTolerance) {
                    phase.add(new Integer(i-noise+1));
                    noise = 0;
                }
            } else {
                noise = 0;
            }
        }*/

        return phase;
    }
}
