/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: May 6, 2003
 * Time: 3:13:14 PM
 */

package EVolve.util.phasedetectors;

import java.util.Stack;

import EVolve.util.HelperFuncs;

public class PhaseFrame implements Cloneable{
    public Stack undoList;
    public Stack redoList;
    public Stack undoParams;
    public Stack redoParams;

    public PhaseFrame() {
        undoList = new Stack();
        redoList = new Stack();
        undoParams = new Stack();
        redoParams = new Stack();
    }

    public Object clone() {
        PhaseFrame o = null;
        try {
            o = (PhaseFrame)super.clone();
        } catch (CloneNotSupportedException e) {
            System.out.println(e.getStackTrace());
            return o;
        }

        o.undoList = HelperFuncs.cloneStack(undoList);
        o.redoList = HelperFuncs.cloneStack(redoList);
        o.undoParams = HelperFuncs.cloneStack(undoParams);
        o.redoParams = HelperFuncs.cloneStack(redoParams);
        return o;
    }
}
