/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Apr 1, 2003
 * Time: 9:59:07 PM
 */

package EVolve.util.settings;

import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;

import javax.swing.JTextField;

import EVolve.Scene;

public class PhaseDetectorSetting extends Setting{
    private static PhaseDetectorSetting instance;

    public static PhaseDetectorSetting v() {
        if (instance == null)
            instance = new PhaseDetectorSetting();
        return instance;
    }

    public void save(String tags[], JTextField contents[], String filename) {
        this.contents = contents;
        this.tags = tags;
        iniFilename = getFilenameWithPath(filename);
        save();
    }

    public void readDataFromFile(String tags[], JTextField[] contents, String filename) {
        String line;
        RandomAccessFile iniFile;
        File file = new File(getFilenameWithPath(filename));
        if (!file.exists()) return;

        try {
            iniFile = new RandomAccessFile(file,"r");
            for (int i=0; i<tags.length; i++) {
                line = iniFile.readLine(); //skip tag
                line = iniFile.readLine();
                contents[i].setText(line.trim());
            }
        } catch (IOException e) {
            Scene.showErrorMessage("Unable to read setting file \""+iniFilename+"\", or" +
                                   "the file is corrupted.");
            return;
        } catch (NumberFormatException e) {
            Scene.showErrorMessage("Format of \""+iniFilename+"\" is incorrect.");
            return;
        }

    }

}
