/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Apr 2, 2003
 * Time: 7:54:26 PM
 */

package EVolve.util.settings;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JDialog;
import javax.swing.JTextField;

import EVolve.Scene;

public abstract class Setting {
    protected String iniFilename;
    protected String tags[];
    protected JTextField contents[];
    protected JDialog dialog;

    protected String getFilenameWithPath(String name) {
        boolean isRunningUnderWindows = System.getProperty("os.name").startsWith("Windows");
        String userHome = System.getProperty("user.home");
        String configFile = null;
        if (userHome == null || userHome.trim().equals("")) {
            // Fall back to current directory if undefined
            userHome = ".";
        }

        if (!userHome.endsWith(String.valueOf(Character.toString(File.separatorChar)))) {
            userHome += File.separatorChar;
        }

        if (isRunningUnderWindows) {
            configFile = name + ".ini";
        } else {
            configFile = "." + name;
        }
        return userHome + configFile;
    }

    protected void save() {
        try {
            FileWriter writer = new FileWriter(iniFilename);
            for (int i=0; i<tags.length; i++) {
                writer.write(tags[i]+"\n");
                writer.write(contents[i].getText()+"\n");

            }
            writer.flush();
            writer.close();
        } catch (IOException e) {
            Scene.showErrorMessage("Unable to update file "+iniFilename);
        }
    }
}
