/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Apr 10, 2003
 * Time: 11:18:01 PM
 */

package EVolve.util.unifyutils;

import java.awt.Color;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;

import EVolve.Scene;
import EVolve.data.Entity;
import EVolve.visualization.AutoImage;
import EVolve.visualization.ReferenceDimension;
import EVolve.visualization.Visualization;

public class Unification {

    public static void unifyEntities(HashMap standard, HashMap toBeUnified) {
        Iterator it = toBeUnified.keySet().iterator();
        while (it.hasNext()) {
            Entity entity = (Entity)toBeUnified.get(it.next());

            if (!standard.containsKey(entity.getName())) {
                standard.put(entity.getName(), entity);
            }
        }
    }

    public static void getUnifiedEntity(HashSet fullEntitySet, ArrayList vizList, int dimension) {
        HashSet dsourceFound = new HashSet();
        HashMap standard = new HashMap();

        for (int i=0; i<vizList.size(); i++) {
            Visualization visual = (Visualization)vizList.get(i);
            Integer dsourceId = new Integer(visual.getDataSourceId());

            if (dsourceFound.contains(dsourceId)) continue;

            dsourceFound.add(dsourceId);

            ReferenceDimension dim = visual.getLinkableDimension(dimension);

            HashMap toBeUnified = Scene.getDataSourceManager().getDataManager(dsourceId.intValue()).getEntity()[dim.getDataFilter().getTargetType()];

            Unification.unifyEntities(standard, toBeUnified);
        }

        Iterator it = standard.keySet().iterator();
        while (it.hasNext()) {
            fullEntitySet.add(standard.get(it.next()));
        }

    }

    public static void changeColor(AutoImage image, Color newColor) {
        int w = image.getW();
        int h = image.getH();

        for (int i=0; i<w; i++) {
            for (int j=0; j<h; j++) {
                Object temp = image.getColor(i,j);
                if ((temp == null)||(newColor==null)) continue;
                image.setColor(i, j,newColor);
            }
        }
    }
}
