/*
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: 4-Sep-2002
 * Time: 1:44:25 PM
 * To change template for new class use
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package EVolve.util.unifyutils;

import java.util.ArrayList;
import java.util.HashSet;

import EVolve.Scene;
import EVolve.exceptions.NoDataPlotException;
import EVolve.visualization.AutoImage;
import EVolve.visualization.ReferenceDimension;
import EVolve.visualization.Visualization;

public class UnifiedVisualization {
    private ArrayList viz;
    private int dimension;
    private HashSet fullEntitySet;

    public UnifiedVisualization(int dimension) {
        this.dimension = dimension;
        viz = new ArrayList();
        fullEntitySet = new HashSet();
    }

    public boolean exists(Visualization visual) {
        boolean retValue = false;
        for (int i=0;i<viz.size();i++) {
            if (((Visualization)viz.get(i)).getVisualizationID() == visual.getVisualizationID()) {
                retValue = true;
            }
        }
        return retValue;
    }

    public void addVisualization(Visualization [] visuals) {

        for (int i=0;i<visuals.length;i++) {
            if (exists(visuals[i])) continue;
            viz.add(viz.size(),visuals[i]);
        }
    }

    public void visualize() {
        ArrayList tobeViz = new ArrayList();
        fullEntitySet.clear();

        for (int i=0; i<viz.size(); i++) {
            Visualization visual = (Visualization)viz.get(i);
            AutoImage image = visual.getImage();
            if (image == null)
                tobeViz.add(visual);
        }

        if (tobeViz.size() != 0) {
            Scene.getVisualizationManager().prepareForLinkedViz(tobeViz,0);
            Scene.visualize();
        }

        Unification.getUnifiedEntity(fullEntitySet,viz,dimension);

        for (int i = 0; i< viz.size(); i++) {
            Visualization visual = (Visualization)viz.get(i);
            ReferenceDimension dim = visual.getLinkableDimension(dimension);
            dim.linkEntities(fullEntitySet);
            try {
                dim.visualize();
            } catch (NoDataPlotException e) {
                Scene.showErrorMessage(e.getMessage());
            }
        }

        for (int i=0; i<viz.size(); i++) {
            ((Visualization)viz.get(i)).visualize();
        }
    }

    public int unregisterViz(Visualization visual) {
        int delCount = 0;
        for (int i=0;i<viz.size();i++) {
            if (((Visualization)viz.get(i-delCount)).getVisualizationID() == visual.getVisualizationID()) {
                viz.remove(i-delCount);
                delCount++;
            }
        }
        if (viz.size() == 1) viz.clear();

        return viz.size();
    }

}
