/*
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: 2002-9-4
 * Time: 13:50:04
 * To change template for new class use
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package EVolve.util.unifyutils;

import java.awt.BorderLayout;
import java.awt.List;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;

import EVolve.Scene;
import EVolve.visualization.ReferenceDimension;
import EVolve.visualization.Visualization;
import EVolve.visualization.XYViz.XYVisualization;

public class UnifiedVisualizationRunner {
    private ArrayList[] unifiedDimension;
    private JDialog dialog;
    private List availableList;
    private List unifiableList;
    private ArrayList unifiableViz;
    private JComboBox comboDimension;
    private int dimension;


    public UnifiedVisualizationRunner() {
        unifiedDimension = new ArrayList[3];
        for (int i=0;i<unifiedDimension.length;i++) unifiedDimension[i] = new ArrayList();
        unifiableViz = new ArrayList();
    }

    public void createDialog() {
        dialog = new JDialog(Scene.getFrame(), "Unifying Visualizations...", true);
        dialog.setBounds(new Rectangle(500,400));

        Box boxMain = new Box(BoxLayout.Y_AXIS);
        boxMain.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),
                "Choose Visualizations to be unified"));
        dialog.getContentPane().add(boxMain,BorderLayout.CENTER);

        Box boxLabels = new Box(BoxLayout.X_AXIS);
        boxLabels.add(new JLabel("Available visualizations:"));
        boxLabels.add(Box.createHorizontalStrut(195));
        boxLabels.add(new JLabel("Unifiable visualizations:"));

        Box boxLinkDimension = new Box(BoxLayout.Y_AXIS);
        boxLinkDimension.setBounds(new Rectangle(20,300));
        comboDimension = new JComboBox();
        comboDimension.setEnabled(false);


        boxLinkDimension.add(Box.createVerticalStrut(40));
        boxLinkDimension.add(new JLabel("Choose unified dimension     "));
        boxLinkDimension.add(Box.createVerticalStrut(10));
        boxLinkDimension.add(comboDimension);
        comboDimension.setBounds(new Rectangle(20,20));
        boxLinkDimension.add(Box.createVerticalStrut(205));
        comboDimension.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                updateLinkableList();
            }
        });


        Box boxLists = new Box(BoxLayout.X_AXIS);
        availableList = new List(6,false);
        ArrayList arr = Scene.getVisualizationManager().getVisualizationList();
        for (int i=0; i<arr.size(); i++) {
            availableList.add((((Visualization)arr.get(i)).getName()));
        }
        availableList.addItemListener(new ItemListener() {
            public void itemStateChanged(ItemEvent e){
                    updateComboDimension();
            }
        });
        unifiableList = new java.awt.List(6,true);
        boxLists.add(availableList);
        boxLists.add(Box.createHorizontalStrut(10));
        boxLists.add(boxLinkDimension);
        boxLists.add(Box.createHorizontalStrut(10));
        boxLists.add(unifiableList);

        boxMain.add(boxLabels);
        boxMain.add(boxLists);

        Box boxOkCancel = new Box(BoxLayout.X_AXIS);
        JButton buttonOK = new JButton("OK");
        JButton buttonCancel = new JButton("Cancel");

        buttonOK.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                onOK();
            }
        });
        buttonCancel.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                onCancel();
            }
        });
        boxOkCancel.add(Box.createHorizontalStrut(180));
        boxOkCancel.add(buttonOK);
        boxOkCancel.add(Box.createHorizontalStrut(20));
        boxOkCancel.add(buttonCancel);

        dialog.getContentPane().add(boxOkCancel,BorderLayout.SOUTH);
    }

    private void updateComboDimension() {
        int index = availableList.getSelectedIndex();

        if (index == -1) return;
        Visualization visual = (Visualization) Scene.getVisualizationManager().getVisualizationList().get(index);
        int[] flags = getLinkableDimension(visual);

        comboDimension.removeAllItems();
        for (int i=0; i<flags.length; i++) {
            switch (i) {
                case 0:
                    if (flags[i] == 1)
                        comboDimension.addItem("X-Axis");
                    break;
                case 1:
                    if (flags[i] == 1)
                        comboDimension.addItem("Y-Axis");
                    break;
                case 2:
                    if (flags[i] == 1)
                        comboDimension.addItem("Z-Axis");
                    break;
            }
        }
        if (comboDimension.getItemCount() != 0) {
            comboDimension.setSelectedIndex(0);
            comboDimension.setEnabled(true);
        } else {
            comboDimension.setEnabled(false);
            unifiableList.removeAll();
        }
    }

    private void updateLinkableList() {
        int index = availableList.getSelectedIndex();
        Visualization visual = (Visualization) Scene.getVisualizationManager().getVisualizationList().get(index);

        String selectedItem = (String)comboDimension.getSelectedItem();
        if (selectedItem.charAt(0) == 'X') {
            dimension = 0;
        } else if (selectedItem.charAt(0) == 'Y') {
            dimension = 1;
        } else {
            dimension = 2;
        }
        unifiableList.removeAll();
        getLinkableVisualization(visual,dimension);
        for (int i=0; i<unifiableViz.size(); i++) {
            unifiableList.add(((Visualization)unifiableViz.get(i)).getName());
        }
    }

    private int[] getLinkableDimension(Visualization visual) {
        int[] returnVal = new int[visual.getDimension().length];

        for (int i=0; i<returnVal.length; i++) {
            if (visual.getLinkableDimension(i) != null )
                returnVal[i] = 1;
            else
                returnVal[i] = 0;
        }
        return returnVal;
    }

    private void getLinkableVisualization(Visualization visual,int dimension) {
        ArrayList arr = Scene.getVisualizationManager().getVisualizationList();

        unifiableViz.clear();
        for (int i=0; i< arr.size(); i++) {
            if (i == availableList.getSelectedIndex()) continue;
            Visualization visual2 = (Visualization)arr.get(i);
            if (isLinkable(visual,visual2,dimension)) unifiableViz.add(visual2);
        }
    }

    public void onOK() {
        int[] indexes = unifiableList.getSelectedIndexes();

        if (indexes.length == 0) {
            Scene.showErrorMessage("Please select visualizations to be linked");
            return;
        }

        Visualization[] viz= new Visualization[indexes.length +1];

        viz[0] = (Visualization)Scene.getVisualizationManager().getVisualizationList().get(availableList.getSelectedIndex());
        for (int i=0; i<indexes.length; i++) {
            viz[i+1] = (Visualization)unifiableViz.get(indexes[i]);
        }
        dialog.setVisible(false);
        newLinkedVisualization(dimension,viz);
        runLinkedVisualization();
    }

    public void onCancel() {
        dialog.setVisible(false);
    }

    public void showWindow() {
        createDialog();
        Scene.getUIManager().showDialog(dialog, dialog.getWidth(), dialog.getHeight());
    }

    public void newLinkedVisualization(int dim, Visualization[] viz) {
        UnifiedVisualization linkedViz = null;
        int linkingNo = -1;

        for (int j =0; j< viz.length; j++) {
            for (int i = 0; i < unifiedDimension[dim].size(); i++) {
                linkedViz = (UnifiedVisualization) unifiedDimension[dim].get(i);
                if (linkedViz.exists(viz[j])) {
                    linkingNo = i;
                    j = viz.length +1;
                    break;
                }
            }
        }

        if (linkingNo == -1) {
            linkedViz = new UnifiedVisualization(dim);
            unifiedDimension[dim].add(linkedViz);
        }

        linkedViz.addVisualization(viz);
    }

    public boolean isLinkable(Visualization visualLinked,Visualization visualLinking,int dim) {
        int typeLinked, typeLinking;
        ReferenceDimension linkableDim = visualLinked.getLinkableDimension(dim);

        if ((visualLinked.getLinkableDimension(dim) == null)||
            (visualLinking.getLinkableDimension(dim) == null)) return false;

        typeLinked = linkableDim.getDataFilter().getTargetType();

        if (visualLinking.getDimension().length<dim+1)
            return false;
        else
            typeLinking = visualLinking.getLinkableDimension(dim).getDataFilter().getTargetType();

        if ((visualLinking.getSubjectDefinition().getName().equals(visualLinked.getSubjectDefinition().getName())) &&
            (visualLinking.getFactory().getName().equals(visualLinked.getFactory().getName())) &&
            (visualLinking.getDimension()[0].getName().equals(visualLinked.getDimension()[0].getName())) &&
            (visualLinking.getDimension()[1].getName().equals(visualLinked.getDimension()[1].getName())) &&
            (visualLinking.getVisualizationID()==visualLinked.getVisualizationID()))
            return false;

        if ((!(visualLinking instanceof XYVisualization))||(!(visualLinked instanceof XYVisualization)))
            return false;

        return (typeLinked == typeLinking ? true : false);
    }

    public void runLinkedVisualization() {
        for (int i=0; i<unifiedDimension.length; i++) {
            for (int j=0; j<unifiedDimension[i].size(); j++) {
                UnifiedVisualization linkedVisualization = (UnifiedVisualization)unifiedDimension[i].get(j);
                linkedVisualization.visualize();
            }
        }
    }

    public void unregisterLinkedViz(Visualization viz) {
        int delCount = 0;
        for (int i=0; i<unifiedDimension.length; i++) {
            for (int j=0; j<unifiedDimension[i].size(); j++) {
                UnifiedVisualization linkedVisualization = (UnifiedVisualization)unifiedDimension[i].get(j-delCount);
                int vizLeft = linkedVisualization.unregisterViz(viz);
                if (vizLeft == 0) {
                    unifiedDimension[i].remove(j-delCount);
                    delCount++;
                }

            }
        }
    }
}
