package EVolve.util.xmlutils.datastructures;

/**
 * User: Wei Wang
 * Date: Jun 4, 2003
 * Time: 4:15:07 PM
 */
import java.util.*;

public class XMLWriteOrder {
    private String visualizations[] = {"VisualizationName","FactoryName","SubjectName","xAxis","xAxisSortScheme",
                                       "yAxis","yAxisSortScheme","zAxis","zAxisSortScheme","PredictorName","PainterName",
                                       "EqualizerName","PlacementName","WindowTitle","Interval","BeginEvent","EndEvent",
                                       "EqualizerSetSize","Threshold","BlockSize","TimeDenotedByBlock","WindowX",
                                       "WindowY", "WindowWidth","WindowHeight"};
    private String serializedData[] = {"EVolveVersion","FileType","ConfigurationName","DataSourceName","TraceFileName",
                                       "AutoLoadTrace","PathForResult","NumberOfVisualizations","NumberOfSelections",
                                       "SelectedSelection","Visualizations","Selections"};
    private String selections[] ={"CurrentSelectionName","StartEventNo","EndEventNo","StartTime","EndTime","TimeMap",
                                  "SourceType","EntityType","EntityCategory","Color","SelectedEntities"};
    private String evolveSetting[] = {"DefaultDataPath","DefaultVizResultPath","DefaultVizConfigurationPath",
                                      "AdditionalClassPath","SourceFilePath"};

    private HashMap orderMap;

    public XMLWriteOrder() {
        orderMap = new HashMap();
        orderMap.put("SerializedVisualizations", visualizations);
        orderMap.put("SerializedData", serializedData);
        orderMap.put("SerializedSelections", selections);
        orderMap.put("EVolveSettingData", evolveSetting);
    }

    public String[] getOrder(String key) {
        return (String[])orderMap.get(key.substring(key.lastIndexOf('.')+1));
    }

}
