/* EVolve - an Extensible Software Visualization Framework
 * Copyright (C) 2001-2002 Qin Wang
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * EVolve is distributed at http://www.sable.mcgill.ca/EVolve/
 */

package EVolve.visualization;

public class DimensionDefinition implements Cloneable{
    private String name; // name of the dimension
    private String property; // property required by the dimension

    /**
     * Creates a dimension definition.
     *
     * @param  name  name of the dimension
     * @param  property  property required by the dimension
     */
    public DimensionDefinition(String name, String property) {
        this.name = name;
        this.property = property;
    }

    /**
     * Gets the name of the dimension.
     *
     * @return  name of the dimension
     */
    public String getName() {
        return name;
    }

    /**
     * Gets the property required by the dimension.
     *
     * @return  property required by the dimension
     */
    public String getProperty() {
        return property;
    }

    public Object clone() {
        DimensionDefinition o = null;
        try {
            o = (DimensionDefinition)super.clone();
        } catch (CloneNotSupportedException e) {
            e.printStackTrace();
            return null;
        }
        o.name = name;
        o.property = property;
        return o;
    }
}