/* EVolve - an Extensible Software Visualization Framework
 * Copyright (C) 2001-2002 Qin Wang
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * EVolve is distributed at http://www.sable.mcgill.ca/EVolve/
 */

package EVolve.visualization;

import java.util.ArrayList;

import EVolve.data.Element;

public class ValueDimension extends Dimension {
    private long counter;
    private long sum;
    private ArrayList property;

    public ValueDimension() {
        super();
        property = new ArrayList();
    }

    public void preVisualize() {
        counter = 0;
        sum = 0;
        property.clear();
        String[] temp = dataFilter.getProperty();
        for (int i = 0; i< temp.length; i++) {
            property.add(temp[i]);
        }
    }

    public long getField(Element element) {
        long returnVal = dataFilter.getData(element);

        if (property.contains("sum")) {
            sum += returnVal;
            returnVal = sum;
        } else if (property.contains("count")) {
            if (returnVal == 0)
                returnVal = counter;
            else
                returnVal = ++counter;
        }

        return returnVal;
    }

    public Object clone() {
        ValueDimension o = null;
        o = (ValueDimension)super.clone();
        o.property = (ArrayList)property.clone();
        return o;
    }
}