/* EVolve - an Extensible Software Visualization Framework
 * Copyright (C) 2001-2002 Qin Wang
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * EVolve is distributed at http://www.sable.mcgill.ca/EVolve/
 */

package EVolve.visualization;

public class VisualizationDefinition implements Cloneable{
    private DimensionDefinition[] dimensionDefinition; // definition of the dimensions

    /**
     * Creates a visualization definition.
     *
     * @param  subjectType  type of the subject, either ElementBuilder.TYPE_ENTITY or ElementBuilder.TYPE_EVENT
     * @param  dimensionDefinition  definition of the dimensions
     */
    public VisualizationDefinition(DimensionDefinition[] dimensionDefinition) {
        this.dimensionDefinition = dimensionDefinition;
    }

    /**
     * Gets the definition of the dimensions.
     *
     * @return  definition of the dimensions
     */
    public DimensionDefinition[] getDimensionDefinition() {
        return dimensionDefinition;
    }

    public Object clone() {
        VisualizationDefinition o = null;
        try {
            o = (VisualizationDefinition)super.clone();
        } catch (CloneNotSupportedException e) {
            e.printStackTrace();
            return null;
        }

        o.dimensionDefinition = new DimensionDefinition[dimensionDefinition.length];
        for (int i=0; i<dimensionDefinition.length; i++)
            o.dimensionDefinition[i] = (DimensionDefinition)dimensionDefinition[i].clone();

        return o;
    }
}