/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Feb 9, 2003
 * Time: 4:35:46 PM
 */

package EVolve.visualization.VizFactory;

import java.util.ArrayList;

import EVolve.visualization.DimensionDefinition;
import EVolve.visualization.PredictorFactory;
import EVolve.visualization.Visualization;
import EVolve.visualization.VisualizationDefinition;
import EVolve.visualization.XYViz.ValValViz.EventViz;

public class EventVizFactory extends VisualizationFactory{
    protected ArrayList factoryList; // predictor factories

    public EventVizFactory() {
        factoryList = new ArrayList();
    }

    public String getName() {
        return "Event Visualization";
    }

    public String getFactoryName() {
        return "EventVizFactory";
    }

    public void addPredictorFactory(PredictorFactory factory) {
        factoryList.add(factory);
    }

    public VisualizationDefinition createDefinition() {
        DimensionDefinition[] dimensionDefinition = new DimensionDefinition[3];
        dimensionDefinition[0] = new DimensionDefinition("Events", "count");
        dimensionDefinition[1] = new DimensionDefinition("Show", "reference");
        dimensionDefinition[2] = new DimensionDefinition("Prediction", "reference");
        return new VisualizationDefinition(dimensionDefinition);
    }

    public Visualization createVisualization() {
        PredictorFactory[] factory = new PredictorFactory[factoryList.size()];
        for (int i = 0; i < factory.length; i++) {
            factory[i] = (PredictorFactory)(factoryList.get(i));
        }
        return new EventViz(factory);
    }
}
