/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Apr 28, 2003
 * Time: 5:56:49 PM
 */

package EVolve.visualization.VizFactory;

import EVolve.visualization.DimensionDefinition;
import EVolve.visualization.Visualization;
import EVolve.visualization.VisualizationDefinition;
import EVolve.visualization.XYViz.ValValViz.HardwareCounterViz;

public class HardwareCounterVizFactory  extends VisualizationFactory{
    public String getName() {
        return "Hardware Counter Metric";
    }

    public String getFactoryName() {
        return "HardwareCounterVizFactory";
    }

    public VisualizationDefinition createDefinition() {
        DimensionDefinition[] dimensionDefinition = new DimensionDefinition[3];
        dimensionDefinition[0] = new DimensionDefinition("X-axis", "bytecode");
        dimensionDefinition[1] = new DimensionDefinition("Y-axis", "eventvalue");
        dimensionDefinition[2] = new DimensionDefinition("Color", "reference");
        return new VisualizationDefinition(dimensionDefinition);
    }

    public Visualization createVisualization() {
        return new HardwareCounterViz();
    }
}
