/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Dec 6, 2002
 * Time: 4:04:59 PM
 */

package EVolve.visualization.VizFactory;

import EVolve.visualization.DimensionDefinition;
import EVolve.visualization.Visualization;
import EVolve.visualization.VisualizationDefinition;
import EVolve.visualization.XYViz.ValRefViz.HotSpotViz.HotSpotVisualization;

public class HotspotVizFactory extends VisualizationFactory{
    public String getName() {
        return "Hot Spot";
    }

    public String getFactoryName() {
        return "HotspotVizFactory";
    }

    public VisualizationDefinition createDefinition() {
        DimensionDefinition[] dimensionDefinition = new DimensionDefinition[2];
        dimensionDefinition[0] = new DimensionDefinition("X-axis", "time");
        dimensionDefinition[1] = new DimensionDefinition("Y-axis", "reference");
        return new VisualizationDefinition(dimensionDefinition);
    }

    public Visualization createVisualization() {
        return new HotSpotVisualization();
    }

}
