/*
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * ACL Lab, School of Computer Science, Montreal, QC
 * Date: 2002-9-15
 * Time: 20:12:25
 */
package EVolve.visualization.VizFactory;

import EVolve.visualization.DimensionDefinition;
import EVolve.visualization.PredictorFactory;
import EVolve.visualization.Visualization;
import EVolve.visualization.VisualizationDefinition;
import EVolve.visualization.XYViz.ValValViz.MissPredictionMetricViz;

public class MissPredictionMetricVizFactory extends PredictionVizFactory {

    public String getName() {
        return "Miss Prediction";
    }

    public String getFactoryName() {
        return "MissPredictionMetricVizFactory";
    }

    public VisualizationDefinition createDefinition() {
        DimensionDefinition[] dimensionDefinition = new DimensionDefinition[3];
        dimensionDefinition[0] = new DimensionDefinition("X-axis", "coordinate");
        dimensionDefinition[1] = new DimensionDefinition("Predict on", "reference");
        dimensionDefinition[2] = new DimensionDefinition("Predict", "reference");
        return new VisualizationDefinition(dimensionDefinition);
    }

    public Visualization createVisualization() {
        PredictorFactory[] factory = new PredictorFactory[factoryList.size()];
        for (int i = 0; i < factory.length; i++) {
            factory[i] = (PredictorFactory)(factoryList.get(i));
        }
        return new MissPredictionMetricViz(factory);
    }

}
