/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Feb 14, 2003
 * Time: 9:16:03 PM
 */

package EVolve.visualization.VizFactory;

import EVolve.visualization.DimensionDefinition;
import EVolve.visualization.Visualization;
import EVolve.visualization.VisualizationDefinition;
import EVolve.visualization.XYViz.RefRefViz.RelationshipViz;

public class RelationshipVizFactory extends VisualizationFactory{
    public String getName() {
        return "Relationship Graph";
    }

    public String getFactoryName() {
        return "RelationshipVizFactory";
    }

    public VisualizationDefinition createDefinition() {
        DimensionDefinition[] dimensionDefinition = new DimensionDefinition[3];
        dimensionDefinition[0] = new DimensionDefinition("Object One", "reference");
        dimensionDefinition[1] = new DimensionDefinition("Object Two", "reference");
        dimensionDefinition[2] = new DimensionDefinition("Relationship", "amount");
        return new VisualizationDefinition(dimensionDefinition);
    }

    public Visualization createVisualization() {
        return new RelationshipViz();
    }
}
