/*
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: 2002-9-19
 * Time: 13:39:33
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package EVolve.visualization.VizFactory;

import EVolve.visualization.DimensionDefinition;
import EVolve.visualization.Visualization;
import EVolve.visualization.VisualizationDefinition;
import EVolve.visualization.XYViz.ValValViz.StackViz;


public class StackVizFactory extends VisualizationFactory{

    public StackVizFactory() {
    }

    public String getName() {
        return "Stack Visualization";
    }

    public String getFactoryName() {
        return "StackVizFactory";
    }

    public VisualizationDefinition createDefinition() {
        DimensionDefinition[] dimensionDefinition = new DimensionDefinition[3];
        dimensionDefinition[0] = new DimensionDefinition("X-axis", "count");
        dimensionDefinition[1] = new DimensionDefinition("Y-axis", "reference");
        dimensionDefinition[2] = new DimensionDefinition("Thread", "thread");
        return new VisualizationDefinition(dimensionDefinition);
    }

    public Visualization createVisualization() {
        return new StackViz();
    }

}
