/* EVolve - an Extensible Software Visualization Framework
 * Copyright (C) 2001-2002 Qin Wang
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * EVolve is distributed at http://www.sable.mcgill.ca/EVolve/
 */

package EVolve.visualization.VizFactory;

import EVolve.visualization.DimensionDefinition;
import EVolve.visualization.TableViz;
import EVolve.visualization.Visualization;
import EVolve.visualization.VisualizationDefinition;

/**
 * Factory of table.
 */
public class TableVizFactory extends VisualizationFactory {
    public String getName() {
        return "Table";
    }

    public String getFactoryName() {
        return "TableVizFactory";
    }

    public VisualizationDefinition createDefinition() {
        DimensionDefinition[] dimensionDefinition = new DimensionDefinition[2];
        dimensionDefinition[0] = new DimensionDefinition("Left Column", "reference");
        dimensionDefinition[1] = new DimensionDefinition("Right Column", "amount");
        return new VisualizationDefinition(dimensionDefinition);
    }

    public Visualization createVisualization() {
        return new TableViz();
    }

}