/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Nov 28, 2002
 * Time: 2:27:40 AM
 */

package EVolve.visualization.XYViz.ValRefViz.HotSpotViz;

import EVolve.data.Element;
import EVolve.util.painters.ThreadHotspotPainter;
import EVolve.util.painters.Painter;
import EVolve.visualization.Dimension;
import EVolve.visualization.ReferenceDimension;
import EVolve.visualization.ValueDimension;

public class ThreadHotspotViz extends HotSpotVisualization{

    public ThreadHotspotViz() {
        super();
        painters = new Painter[1];
        painters[0] = new ThreadHotspotPainter();
    }

    public Dimension[] createDimension() {
        Dimension [] returnDimension = new Dimension[3];

        xAxis = new ValueDimension();
        yAxis = new ReferenceDimension(true);
        zAxis = new ReferenceDimension();

        returnDimension[0] = xAxis;
        returnDimension[1] = yAxis;
        returnDimension[2] = zAxis;

        return returnDimension;
    }

    public void preVisualize() {
        super.preVisualize();
        image = null;
    }

    public void receiveElement(Element element) {
        if (element.isOptional()) return;

        long threadId = zAxis.getField(element);

        switchThread(threadId);

        long x = xAxis.getField(element);
        long y = yAxis.getField(element);
        long z = 0;
        paint(x,y,z);
    }

    public void visualize() {
        image = ((ThreadHotspotPainter)painter).getImage();
        super.visualize();
    }

    protected void installPainter() {
        ((ThreadHotspotPainter)painters[0]).setImageMap(imageMap);
        super.installPainter();
    }
}
