/**
 * Created by IntelliJ IDEA.
 * User: Wei Wang
 * Date: Nov 30, 2002
 * Time: 2:11:24 PM
 */

package EVolve.visualization.XYViz.ValValViz;

import EVolve.Scene;
import EVolve.data.Selection;
import EVolve.exceptions.*;
import EVolve.visualization.*;
import EVolve.visualization.XYViz.XYVisualization;

public abstract class ValueValueVisualization extends XYVisualization{
    protected ValueDimension xAxis,yAxis;
    protected ReferenceDimension entityIdFilter,filter2; // use to decide color of a dot
    protected int subjectIndex;
    protected long beginCall, endCall;

    public ReferenceDimension getLinkableDimension(int dim) {
        return null;
    }

    public void sort() {
        try {
            canvas.setImage(image.getImage());
            canvas.repaint();
            enableBrowseSourceMenu();
        } catch (NoDataPlotException e) {
            Scene.showErrorMessage(e.getMessage());
        }
    }

    public void preVisualize() {
        timeMap.clear();
        xOffset = -1;
        timeMap.clear();
    }

    protected void getSelection() {
        Selection selection = Scene.getFilter().getActiveSelection();

        if (selection != null) {
            beginCall = 0;
            endCall = Integer.MAX_VALUE/2;
        }
    }

    protected String getEntityUnderMouse() {
        return null;
    }

    protected void changeOrientation() {
    }

    protected long[] findEventInterval(long startTime, long endTime) {
        long time[] = new long[2], event[] = new long[2];
        time[0] = startTime;
        time[1] = endTime;
        event[0] = 0;
        event[1] = Long.MAX_VALUE;

        if (timeMap != null) {
            for (int i=0; i<time.length; i++) {
                long lastTarget = -1;
                for (int j = 0; j< timeMap.size(); j++) {
                    long[] map = (long[])timeMap.get(j);
                    if ((lastTarget<= time[i])&&(map[0]>=time[i])) {
                        event[i] = map[1];
                        break;
                    }
                }
            }
        }
        return event;
    }

    public Object clone() {
        ValueValueVisualization o = null;
        o = (ValueValueVisualization)super.clone();

        o.xAxis = (ValueDimension)xAxis.clone();
        o.yAxis = (yAxis == null) ? null : (ValueDimension)yAxis.clone();
        o.entityIdFilter = (entityIdFilter == null) ? null : (ReferenceDimension)entityIdFilter.clone();
        o.filter2 = (filter2 == null) ? null : (ReferenceDimension)filter2.clone();
        o.panelConfiguration = o.createConfigurationPanel();
        o.createMenu();
        return o;
    }
}
